<?php

if (!defined('ABSPATH')) {
	die;
}

if (!class_exists('Af_Add_Section')) {

	class Af_Add_Section extends WC_Settings_Page {
	

		public function __construct() {

			$this->id = 'ad_donat_add_seting_tab';

			add_filter('woocommerce_settings_tabs_array', array( $this, 'add_settings_tab' ), 50);

			add_action('woocommerce_sections_' . $this->id, array( $this, 'output_sections' ));

			add_action('woocommerce_settings_' . $this->id, array( $this, 'output' ));

			add_action('woocommerce_settings_save_' . $this->id, array( $this, 'save' ));

			add_action('admin_enqueue_scripts', array( $this, 'af_wc_add_assets_file_enq' ));

			add_action('woocommerce_admin_field_af_donat_chbk_id', array( $this, 'af_donat_tbl_chkbx' ));

			add_action('woocommerce_admin_field_af_donation_message', array( $this, 'addf_gift_registry_co_reg_email_syntax' ));

			add_action('woocommerce_admin_settings_sanitize_option_af_donat_notify_msg_editor_id', array( $this, 'addf_gift_registry_co_reg_email_syntax_val' ), 10, 3);
		}

		public function af_wc_add_assets_file_enq() {

			wp_enqueue_style('af_donat_sect_css', plugins_url('assets/css/af_wc_donate_metabox_css.css', __FILE__), false, '1.0', false);
		}

		public function add_settings_tab( $settings_tabs ) {
			$settings_tabs[ $this->id ] = __('Donation', 'af_donation');
			return $settings_tabs;
		}

		public function get_sections() {
			$chek_sect_page = 'true';
			?>

<input type="hidden" name="chek_sect_page" class="chek_sect_page" value="<?php echo esc_attr($chek_sect_page); ?>">
			<?php
			$sections = array(
				''                    => __('General Setting', 'af_donation'),
				'cart_setting'        => __('Cart Setting', 'af_donation'),
				'checkout_setting'    => __('Checkout Setting', 'af_donation'),
				'af_donat_styling'    => __('Styling', 'af_donation'),
				'af_donat_short_code' => __('Short Code', 'af_donation'),
				'af_donat_notify_msg' => __('Notification', 'af_donation'),
			);
			return apply_filters('woocommerce_get_sections_' . $this->id, $sections);
		}

		public function af_donat_tbl_chkbx( $value ) {
			?>
<div>
	<th class="titledesc"><label
			for="af_dona_cart_option"><?php echo esc_html__('Disable Specific table column', 'af_donation'); ?></label>
	</th>
	<td class="forminp forminp-select">
		<fieldset>

			<ul class="af_style_sect_field">
				<li>
					<input type="checkbox" name="af_donat_tble_clmn_disa[0]" value="yes"
						<?php echo !empty(get_option('af_donat_tble_clmn_disa')[0]) == 'yes' ? 'checked' : ''; ?>><span><?php echo esc_html__('Disable Thumbnail', 'af_donation'); ?></span>
				</li>
				<li>
					<input type="checkbox" name="af_donat_tble_clmn_disa[1]" value="yes"
						<?php echo !empty(get_option('af_donat_tble_clmn_disa')[1]) == 'yes' ? 'checked' : ''; ?>><span><?php echo esc_html__('Disable Description', 'af_donation'); ?></span>
				</li>
				<li>
					<input type="checkbox" name="af_donat_tble_clmn_disa[2]" value="yes"
						<?php echo !empty(get_option('af_donat_tble_clmn_disa')[2]) == 'yes' ? 'checked' : ''; ?>><span><?php echo esc_html__('Disable Causes', 'af_donation'); ?></span>
				</li>
				<li class="af_chbx">
					<input type="checkbox" name="af_donat_tble_clmn_disa[3]" value="yes"
						<?php echo 'checked'; ?>><span><?php echo esc_html__('Disable Causes', 'af_donation'); ?></span>
				</li>
			</ul>
			<p><?php echo esc_html__('Choose to disable any column of table (Table format)', 'af_donation'); ?></p>
		</fieldset>
	</td>
</div>
			<?php
		}



		public function get_settings( $section = null, $settings = null ) {
			$settings = array();
			if (null == $section) {

				$settings[] = array(
					'name' => __('General Settings', 'af_donation'),
					'type' => 'title',
					'id'   => 'af_donat_cart_setting',
				);

				$settings[] = array(
					'name' => 'Disable Specific table column',
					'id'   => 'af_donat_tble_clmn_disa',
					'type' => 'af_donat_chbk_id',
				);

				$settings[] = array(
					'type' => 'sectionend',
					'id'   => 'af_dynamic_discounts_ge_sections',
				);
			} elseif ('cart_setting' == $section) {

				// Add Title to the Settings
				$settings[] = array(
					'name' => __('Cart Settings', 'af_donation'),
					'type' => 'title',
					'id'   => 'af_donat_cart_setting',
				);
				$settings[] = array(
					'name'    => __('Choose Location', 'af_donation'),
					'id'      => 'af_dona_cart_option',
					'type'    => 'select',
					'desc'    => esc_html__('Choose location to show campaigns', 'af_donation'),
					'options' => array(
						'Aftr_crt_tbl' => __('After cart table', 'af_donation'),
						'Bfr_Crt_tbl'  => __('Before cart table', 'af_donation'),
						'Aftr_crt'     => __('After cart ', 'af_donation'),
					),
				);
				$settings[] = array(
					'name'    => __('Display Type(campaigns)', 'af_donation'),
					'id'      => 'af_cart_display_typ',
					'class'   => 'af_cart_display_typ',
					'type'    => 'radio',
					'options' => array(
						'on_page'  => __('On page.', 'af_donation'),
						'on_popup' => __('On pop up.', 'af_donation'),

					),
				);

				$settings[] = array(
					'name' => __('Pop Up Heading', 'af_donation'),
					'id'   => 'af_cart_popup_hadng',
					'type' => 'text',
					'desc' => esc_html__('Add heading of pop up screen.', 'af_donation'),

				);

				$settings[] = array(
					'name'    => __('Display Format(Popup)', 'af_donation'),
					'id'      => 'af_cart_display_format',
					'class'   => 'af_cart_display_format',
					'type'    => 'radio',
					'options' => array(
						'auto_show' => __('Auto show.', 'af_donation'),
						'butn'      => __('Show Button', 'af_donation'),

					),
				);

				$settings[] = array(
					'name' => __('Show Popup Button Text', 'af_donation'),
					'id'   => 'af_cart_shw_btn_txt',
					'type' => 'text',
					'desc' => esc_html__('Add text of button show on page to open popup.', 'af_donation'),

				);

				$settings[] = array(
					'name'    => __('Choose Format', 'af_donation'),
					'id'      => 'af_donat_cart_option',
					'type'    => 'select',
					'desc'    => esc_html__('Choose campaign display format.', 'af_donation'),
					'options' => array(
						'af_tbl_disp'  => __('Table', 'af_donation'),
						'af_flx_disp'  => __('Flex', 'af_donation'),
						'af_list_disp' => __('List', 'af_donation'),
					),
				);


				$settings[] = array(
					'type' => 'sectionend',
					'id'   => 'af_dynamic_discounts_gen_sections',
				);
			} elseif ('checkout_setting' == $section) {
				$settings[] = array(
					'name' => __('Checkout Settings', 'af_donation'),
					'type' => 'title',
					'id'   => 'af_donat_chkout_setting',
				);
				$settings[] = array(
					'name'    => __('Choose Location', 'af_donation'),
					'id'      => 'af_dona_chkt_option',
					'type'    => 'select',
					'desc'    => esc_html__('Choose location to show campaigns', 'af_donation'),
					'options' => array(
						'bfr_order_rev'     => __('Review Order Before Payment', 'af_donation'),
						'rev_ordr_aftr_sub' => __('Review Order After Payment', 'af_donation'),

					),
				);
				$settings[] = array(
					'name'    => __('Display Type(campaigns)', 'af_donation'),
					'id'      => 'af_dona_chkt_disp_opt',
					'class'   => 'af_dona_chkt_disp_opt',
					'type'    => 'radio',
					'options' => array(
						'on_page'  => __('On page.', 'af_donation'),
						'on_popup' => __('On pop up.', 'af_donation'),

					),
				);

				$settings[] = array(
					'name' => __('Heading On Checkout Page', 'af_donation'),
					'id'   => 'af_chkt_page_hadng',
					'type' => 'text',
					'desc' => esc_html__('Add heading to show on checkout page to display donation options.', 'af_donation'),

				);

				$settings[] = array(
					'name' => __('Multiple donation', 'af_donation'),
					'id'   => 'af_chkt_alow_mul_donat',
					'type' => 'checkbox',
					'desc' => esc_html__('Enable, allow user to select multiple option to open popup and display multiple donation(option show on page selection).', 'af_donation'),

				);

				$settings[] = array(
					'name' => __('Pop Up Heading', 'af_donation'),
					'id'   => 'af_chkt_popup_hadng',
					'type' => 'text',
					'desc' => esc_html__('Add heading of pop up screen.', 'af_donation'),

				);

				$settings[] = array(
					'name'    => __('Display Format(Popup)', 'af_donation'),
					'id'      => 'af_dona_chkt_disp_frmt',
					'class'   => 'af_dona_chkt_disp_frmt',
					'type'    => 'radio',
					'options' => array(
						'auto_show' => __('Auto show.', 'af_donation'),
						'butn'      => __('Show Button', 'af_donation'),

					),
				);

				$settings[] = array(
					'name' => __('Show Popup Button Text', 'af_donation'),
					'id'   => 'af_chkt_shw_btn_txt',
					'type' => 'text',
					'desc' => esc_html__('Add text of button show on page to open popup.', 'af_donation'),

				);

				$settings[] = array(
					'name'    => __('Choose Format', 'af_donation'),
					'id'      => 'af_dona_chkt_disp_optn',
					'type'    => 'select',
					'desc'    => esc_html__('Choose campaign display format.', 'af_donation'),
					'options' => array(
						'af_tbl_disp'  => __('Table', 'af_donation'),
						'af_flx_disp'  => __('Flex', 'af_donation'),
						'af_list_disp' => __('List', 'af_donation'),
					),
				);




				$settings[] = array(
					'type' => 'sectionend',
					'id'   => 'af_dynamic_discounts_table_section',
				);
			} elseif ('af_donat_styling' == $section) {
				$settings[] = array(
					'name' => __('Styling', 'af_donation'),
					'type' => 'title',
					'id'   => 'af_donat_styling_setting',
				);

				$settings[] = array(
					'name' => __('Progress Bar Color', 'af_donation'),
					'id'   => 'af_dona_bar_clr',
					'type' => 'color',
					'desc' => esc_html__('Choose donation bar color.', 'af_donation'),

				);
				$settings[] = array(
					'name' => __('Bar Font Color', 'af_donation'),
					'id'   => 'af_dona_font_clr',
					'type' => 'color',
					'desc' => esc_html__('Choose font color of progress bar.', 'af_donation'),

				);

				$settings[] = array(
					'name' => __('Donate Button Text', 'af_donation'),
					'id'   => 'af_dona_btn_txt',
					'type' => 'text',
					'desc' => esc_html__('Add Donate button text.', 'af_donation'),

				);

				$settings[] = array(
					'name' => __('Donate Button Color', 'af_donation'),
					'id'   => 'af_dona_btn_clr',
					'type' => 'color',
					'desc' => esc_html__('Choose color of Donate button(background).', 'af_donation'),

				);
				$settings[] = array(
					'name' => __('Donate Button Font Color', 'af_donation'),
					'id'   => 'af_dona_btn_fnt_clr',
					'type' => 'color',
					'desc' => esc_html__('Choose color of Donate button(font).', 'af_donation'),

				);

				$settings[] = array(
					'name' => __('Open Popup Button Color', 'af_donation'),
					'id'   => 'af_dona_shw_btn_bg_clr',
					'type' => 'color',
					'desc' => esc_html__('Add color of button show on page to open popup for donation(background).', 'af_donation'),

				);

				$settings[] = array(
					'name' => __('Open Popup Button Font Color', 'af_donation'),
					'id'   => 'af_dona_shw_btn_fnt_clr',
					'type' => 'color',
					'desc' => esc_html__('Add color of button show on page to open popup for donation(font).', 'af_donation'),

				);


				$settings[] = array(
					'type' => 'sectionend',
					'id'   => 'af_dynamic_discounts_table_section',
				);
			} elseif ('af_donat_short_code' == $section) {
				$this->af_wc_donat_shortcode_descp();
			} elseif ('af_donat_notify_msg' == $section) {

				$settings[] = array(
					'name' => __('Notification Message', 'af_donation'),
					'type' => 'title',
					'id'   => 'af_donat_msg_setting',
				);

				$settings[] =  array(
					'name'  => esc_html__(' Notification Message', 'af_donation'),
					'type'  => 'af_donation_message',
					'class' => 'addf_gf_email_tab_ops',
					'id'    => 'af_donat_notify_msg_editor_id',

				);


				$settings[] = array(
					'type' => 'sectionend',
					'id'   => 'af_dynamic_discounts_table_section',
				);
			} elseif ('af_donat_email_msg' == $section) {

				$settings[] = array(
					'name' => __('Email Message', 'af_donation'),
					'type' => 'title',
					'id'   => 'af_donat_msg_setting',
				);

				$settings[] =  array(
					'name'  => esc_html__('Admin Message', 'af_donation'),
					'type'  => 'af_donation_message',
					'class' => 'addf_gf_email_tab_ops',
					'desc'  => esc_html__('Message received by admin.', 'af_donation'),
					'id'    => 'af_donat_admin_msg_editor_id',

				);



				$settings[] =  array(
					'name'  => esc_html__('Customer Message', 'af_donation'),
					'type'  => 'af_donation_message',
					'class' => 'addf_gf_email_tab_ops',
					'desc'  => esc_html__('Message received by Customer.', 'af_donation'),
					'id'    => 'af_donat_cust_msg_editor_id',

				);

				$settings[] = array(
					'type' => 'sectionend',
					'id'   => 'af_dynamic_discounts_table_section',
				);
			}



			return apply_filters('wc_settings_tab_afadvqty_settings', $settings, $section);
		}



		public function addf_gift_registry_co_reg_email_syntax( $value ) {

			$option_value = WC_Admin_Settings::get_option($value['id'], $value['default']);
			?>
<tr valign="top">
	<th scope="row" class="titledesc">
		<label for="<?php echo esc_attr($value['id']); ?>"><?php echo esc_html($value['title']); ?></label>
	</th>
	<td class=" af_dont_msg-<?php echo esc_html($value['type']); ?> ">
			<?php echo esc_html($value['desc']); ?>
			<?php wp_editor($option_value, esc_attr($value['id'])); ?>
		<p> <?php echo esc_html__(' Use {campaign_name} to display campaign name in notification message', 'af_donation'); ?>
		</p>
	</td>
</tr>
<tr>

</tr>
			<?php
		}

		public function addf_gift_registry_co_reg_email_syntax_val( $value, $option, $raw_value ) {
			update_option($option['id'], $raw_value);
		}

		/**
		 * Output the settings
		 */

		public function output() {
			global $current_section;
			$settings = $this->get_settings($current_section);
			if (!empty($settings)) {
				WC_Admin_Settings::output_fields($settings);
			}
		}
		/**
		 * Save settings
		 */

		public function save() {
			global $current_section;
			$settings = $this->get_settings($current_section);
			WC_Admin_Settings::save_fields($settings);
		}

		public function af_wc_donat_shortcode_descp() {
			?>
<table class="af_wc_donat_shortcode_descp">
	<tr>
		<td>
			<h3><?php echo esc_html__('Short code', ' af_donation'); ?></h3>
		</td>
		<td>
			<h3><?php echo esc_html__('[af_donation_campaigns ids = display_type = display_format = ]', ' af_donation'); ?>
			</h3>
		</td>
	</tr>
	<tr>
		<td></td>
		<td>
			<p><?php echo esc_html__('Using this short code you can display donation options anywhere on the website, whether it is a shop, product, cart, or checkout page.', ' af_donation'); ?>
			</p>
			<p id="af_p1">
				<?php echo esc_html__('i.e. [af_donation_campaigns ids = "11,12,20" display_type = "popup" display_format = "list"]', ' af_donation'); ?>
			</p>
		</td>
	</tr>


</table>




<table class="af_wc_donat_shortcode_descp">
	<tr>
		<td>
			<h4><?php echo esc_html__('Attributes', ' af_donation'); ?></h4>
		</td>
		<td>
			<h4><?php echo esc_html__('Description', ' af_donation'); ?></h4>
		</td>
	</tr>
	<tr>
		<td><label><?php echo esc_html__('ids', ' af_donation'); ?></label></td>
		<td><label><?php echo esc_html__('Display specific campaign add campaign id(s).', ' af_donation'); ?></label>
		</td>
	</tr>
	<tr>
		<td><label><?php echo esc_html__('display_type', ' af_donation'); ?></label></td>
		<td><label><?php echo esc_html__('Add display type to show campaign(s) (page, auto_popup, popup_button).', ' af_donation'); ?></label>
		</td>
	</tr>
	<tr>
		<td><label><?php echo esc_html__('display_format', ' af_donation'); ?></label></td>
		<td><label><?php echo esc_html__('Add display format (table, flex, list).', ' af_donation'); ?></label></td>
	</tr>


</table>
			<?php
		}
	}
	return new Af_Add_Section();
}
