<?php

/**
 * Define file.
 *
 * @package           WOOCP
 */
if (!defined('ABSPATH')) {
	die;
}
/**
 * Class start.
 *
 * @package           WOOCP
 */
if (!class_exists('AF_Wc_Donation_Front')) {

	class AF_Wc_Donation_Front {
	

		private $af_donat_price;

		public function __construct() {

			add_shortcode('af_donation_campaigns', array( $this, 'af_donat_camp_shrtcod' ));

			add_action('wp_enqueue_scripts', array( $this, 'af_wc_add_front_stylling' ));

			add_action('woocommerce_single_product_summary', array( $this, 'af_donate_progress_bar' ));

			add_action('woocommerce_before_calculate_totals', array( $this, 'af_donat_set_prod_price' ), 10, 1);

			add_action('woocommerce_cart_item_price', array( $this, 'af_donat_set_price_mini_cart' ), 10, 3);

			add_filter('woocommerce_add_cart_item_data', array( $this, 'af_donat_add_rule_id_to_cart' ), 20, 2);

			add_filter('woocommerce_add_cart_item', array( $this, 'af_donat_add_user_data_in_cart_data' ), 10, 2);

			add_action('woocommerce_simple_add_to_cart', array( $this, 'af_donat_opt_on_prod_page' ), 20);

			add_action('woocommerce_subscription_add_to_cart', array( $this, 'af_donat_opt_on_subs_prod_page' ), 20);

			add_action('woocommerce_before_add_to_cart_button', array( $this, 'af_donat_define_opt_on_subs_prod_page' ), 1, 0);

			add_action('woocommerce_subscription_add_to_cart', array( $this, 'af_remove_btn_qty_single_prod_page' ), 1, 0);

			add_action('woocommerce_simple_add_to_cart', array( $this, 'af_remove_btn_qty_single_prod_page' ), 1, 0);

			add_action('wp_loaded', array( $this, 'af_donat_prod_page_btn' ), 100);

			add_filter('woocommerce_get_item_data', array( $this, 'af_donat_cart_prod_cause_title' ), 10, 2);

			add_action('woocommerce_checkout_create_order_line_item', array( $this, 'af_donat_add_meta_for_cause' ), 10, 4);

			if ('Aftr_crt_tbl' == get_option('af_dona_cart_option')) {
				add_action('woocommerce_after_cart_table', array( $this, 'af_donat_optn_show_crt' ));
			} elseif ('Bfr_Crt_tbl' == get_option('af_dona_cart_option')) {
				add_action('woocommerce_before_cart_table', array( $this, 'af_donat_optn_show_crt' ));
			} elseif ('Aftr_crt' == get_option('af_dona_cart_option')) {
				add_action('woocommerce_after_cart', array( $this, 'af_donat_optn_show_crt' ));
			} else {
				add_action('woocommerce_after_cart_table', array( $this, 'af_donat_optn_show_crt' ));
			}

			if ('bfr_order_rev' == get_option('af_dona_chkt_option')) {
				add_action('woocommerce_review_order_before_payment', array( $this, 'af_donat_optn_show_chkout' ));
			} elseif ('rev_ordr_aftr_sub' == get_option('af_dona_chkt_option')) {
				add_action('woocommerce_review_order_after_payment', array( $this, 'af_donat_optn_show_chkout' ));
			} else {
				add_action('woocommerce_review_order_before_payment', array( $this, 'af_donat_optn_show_chkout' ));
			}

			add_action('woocommerce_cart_calculate_fees', array( $this, 'af_my_add_bacs_fee' ), 100, 1);

			add_action('woocommerce_checkout_order_review', array( $this, 'af_donat_open_card_fee' ));

			add_filter('woocommerce_thankyou', array( $this, 'af_donat_save_camp_data' ), 10, 1);

			add_filter('woocommerce_loop_add_to_cart_link', array( $this, 'af_replace_add_to_cart_button_close_descp' ), 10, 2);
		}


		public function af_wc_add_front_stylling() {

			wp_enqueue_style('af_wc_donat_front_stylling', plugins_url('../assets/css/af_wc_donat_front_stylling.css', __FILE__), false, '1.0.0', false);

			wp_enqueue_style('af_donat_popup_style', plugins_url('../assets/css/af_donat_popup_style.css', __FILE__), false, '1.0.0', false);

			wp_enqueue_script('af_donat_front_js', plugins_url('../assets/js/af_donat_front_js.js', __FILE__), array( 'jquery' ), '1.0.0', false);

			wp_enqueue_script('af_donat_front_popup_js', plugins_url('../assets/js/af_donat_front_popup_js.js', __FILE__), array( 'jquery' ), '1.0.0', false);

			$af_donat_local_scrpt = array(
				'admin_url' => admin_url('admin-ajax.php'),
				'nonce'     => wp_create_nonce('af_donat_nonce'),

			);
			wp_localize_script('af_donat_front_js', 'af_donat_prod_var', $af_donat_local_scrpt);
			$af_donat_bar_font_clr = get_option('af_dona_font_clr');
			$af_donat_bar_clr      = get_option('af_dona_bar_clr');

			if (!empty(get_option('af_dona_shw_btn_bg_clr'))) {
				$af_dona_shw_btn_bg_clr = get_option('af_dona_shw_btn_bg_clr') . '!important';
			} else {
				$af_dona_shw_btn_bg_clr = '#eeeeee';
			}
			if (!empty(get_option('af_dona_shw_btn_fnt_clr'))) {
				$af_dona_shw_btn_fnt_clr = get_option('af_dona_shw_btn_fnt_clr') . '!important';
			} else {
				$af_dona_shw_btn_fnt_clr = '#333333';
			}

			if (!empty(get_option('af_dona_btn_clr'))) {
				$af_dona_btn_clr = get_option('af_dona_btn_clr') . '!important';
			} else {
				$af_dona_btn_clr = '#eeeeee';
			}

			if (!empty(get_option('af_dona_btn_fnt_clr'))) {
				$af_dona_btn_fnt_clr = get_option('af_dona_btn_fnt_clr') . '!important';
			} else {
				$af_dona_btn_fnt_clr = '#333333';
			}

			?>
			<style>

				.af_donat_progress_line {
					background-color: <?php echo esc_attr($af_donat_bar_clr); ?>;
					color: <?php echo esc_attr($af_donat_bar_font_clr); ?>;

				}

				.af_donat_opn_popup {
					margin-bottom:20px;
					background-color: <?php echo esc_attr($af_dona_shw_btn_bg_clr); ?>;
					color: <?php echo esc_attr($af_dona_shw_btn_fnt_clr); ?> ;
				}

				.af_dont_btn_chk {
					background-color: <?php echo esc_attr($af_dona_btn_clr); ?>;
					color: <?php echo esc_attr($af_dona_btn_fnt_clr); ?> ;
				}

			</style>
			<?php
		}


		public function af_replace_add_to_cart_button_close_descp( $button, $product ) {

			$pro_id                      = $product->get_id();
			$af_donat_rule_              = get_post_meta($pro_id, 'af_donation_product_rule', true);
			$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_donat_rule_);

			if (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {
				$this->af_donation_close_msg($af_check_donat_goal_setting['close_donation']);
				update_post_meta($af_donat_rule_, 'af_donatio_close', 'close');

				if ('' == get_post_meta($af_donat_rule_, 'af_donatio_close_date', true)) {

					update_post_meta($af_donat_rule_, 'af_donatio_close_date', gmdate('Y-m-d'));
				}
				return;
			} else {
				return $button;
			}
		}

		public function af_donat_add_user_data_in_cart_data( $data, $cart_item ) {

			global $af_donat_price;
			foreach ($data as $key => $value) {
				if ('data' == $key) {

					foreach ($value->get_meta_data() as $key => $meta_data) {

						if ('_subscription_period' == $meta_data->get_data()['key']) {

							if (!empty($data['subscription_period'])) {
								$meta_data->__set('value', $data['subscription_period']);
								$meta_data->apply_changes();
							}
						}

						if ('_subscription_period_interval' == $meta_data->get_data()['key']) {
							if (!empty($data['subscription_period_interval'])) {
								$meta_data->__set('value', $data['subscription_period_interval']);
								$meta_data->apply_changes();
							}
						}

						if ('_subscription_length' == $meta_data->get_data()['key']) {
							if (!empty($data['subscription_length'])) {
								$meta_data->__set('value', $data['subscription_length']);

								$meta_data->apply_changes();
							}
						}

						if ('_subscription_price' == $meta_data->get_data()['key']) {
							if (!empty($data['donation_amount'])) {
								$meta_data->__set('value', $data['donation_amount']);
								$meta_data->apply_changes();
							}
						}
					}
				}
			}
			return $data;
		}


		public function af_donat_camp_shrtcod( $atts ) {

			$af_donat_shortcode         =    shortcode_atts(array(
				'ids'            => '',
				'display_type'   =>  '',
				'display_format' =>  '',
			), $atts);
			$af_don_prod_id             = $af_donat_shortcode['ids'];
			$af_don_prod_display_type   = $af_donat_shortcode['display_type'];
			$af_don_prod_display_format = $af_donat_shortcode['display_format'];

			if (!empty($af_don_prod_id) && !empty($af_don_prod_display_type) && !empty($af_don_prod_display_format)) {
				$af_don_prod_id = $af_don_prod_id;
				$af_don_prod_id = explode(',', $af_don_prod_id);
				if (is_array($af_don_prod_id)) {

					$this->af_check_disp_formate($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
				}
			} elseif (empty($af_don_prod_id) && empty($af_don_prod_display_type) && empty($af_don_prod_display_format)) {

				$this->af_donat_show_camp_all_attr_list('page', 'flex');
			} elseif (!empty($af_don_prod_id) && empty($af_don_prod_display_type) && empty($af_don_prod_display_format)) {
				$af_don_prod_id = $af_don_prod_id;
				$af_don_prod_id = explode(',', $af_don_prod_id);
				$this->af_donat_camp_onpage_shortcode($af_don_prod_id, 'page', 'flex');
			} elseif (!empty($af_don_prod_id) && !empty($af_don_prod_display_type) && empty($af_don_prod_display_format)) {

				$af_don_prod_id = $af_don_prod_id;
				$af_don_prod_id = explode(',', $af_don_prod_id);
				$this->af_check_disp_formate($af_don_prod_id, $af_don_prod_display_type, 'flex');
			} elseif (empty($af_don_prod_id) && empty($af_don_prod_display_type) && !empty($af_don_prod_display_format)) {

				$this->af_donat_show_camp_all_attr_list('page', $af_don_prod_display_format);
			} elseif (empty($af_don_prod_id) && !empty($af_don_prod_display_type) && !empty($af_don_prod_display_format)) {

				$this->af_donat_show_camp_all_attr_list($af_don_prod_display_type, $af_don_prod_display_format);
			} elseif (empty($af_don_prod_id) && !empty($af_don_prod_display_type) && empty($af_don_prod_display_format)) {

				$this->af_donat_show_camp_all_attr_list($af_don_prod_display_type, 'flex');
			} elseif (!empty($af_don_prod_id) && empty($af_don_prod_display_type) && !empty($af_don_prod_display_format)) {

				$af_don_prod_id = $af_don_prod_id;
				$af_don_prod_id = explode(',', $af_don_prod_id);
				if ('table' == $af_don_prod_display_format) {
					?>
<table>
	<tr>
					<?php
					if (empty(get_option('af_donat_tble_clmn_disa')[0])) {
						?>
		<th class="af_donat_tbl_pic"><?php echo esc_html__('Thumbnail', 'af_donation'); ?></th>
						<?php
					}
					?>
		<th class="af_donat_tbl_cn"> <?php echo esc_html__('Campaign Name', 'af_donation'); ?></th>
					<?php
					if (empty(get_option('af_donat_tble_clmn_disa')[1])) {
						?>
		<th class="af_donat_tbl_des"><?php echo esc_html__('Description', 'af_donation'); ?></th>
						<?php
					}
					?>
					<?php
					if (empty(get_option('af_donat_tble_clmn_disa')[2])) {
						?>
		<th class="af_donat_tbl_caus"><?php echo esc_html__('Causes', 'af_donation'); ?></th>
						<?php
					}
					?>
		<th class="af_donat_tbl_amt"><?php echo esc_html__('Amount', 'af_donation'); ?></th>

		<th class="af_donat_tbl_btn"></th>
	</tr>

					<?php
				}
				$this->af_check_disp_formate($af_don_prod_id, 'page', $af_don_prod_display_format);
				if ('table' == $af_don_prod_display_format) {
					?>
</table>
					<?php
				}
			}
		}


		public function af_check_disp_formate( $af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format ) {

			if ('page' == $af_don_prod_display_type) {

				$this->af_donat_camp_onpage_shortcode($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif ('popup_button' == $af_don_prod_display_type) {
				?>
<input type="button" name="af_donat_opn_popup" class="af_donat_opn_popup" id="myBtn" value="Donate">
				<?php
				$this->af_donat_pop_sett($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif ('auto_popup' == $af_don_prod_display_type) {
				?>
<input type="hidden" name="af_show_auto_popup" class="af_show_auto_popup"
	value="<?php echo esc_html__($af_don_prod_display_type, 'af_donation'); ?>">
				<?php

				$this->af_donat_pop_sett($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif (empty($af_don_prod_display_format)) {

					$this->af_donat_camp_all_attr_list($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			}
		}


		public function af_donat_pop_sett( $af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format ) {

			?>
<div id="myModal" class="modal">
	<div class="modal-content">
		<span class="close">&times;</span>
			<?php
			if ('table' == $af_don_prod_display_format) {

				$this->af_donat_camp_all_attr_table($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif ('flex' == $af_don_prod_display_format) {

				$this->af_donat_camp_all_attr_flex($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif ('list' == $af_don_prod_display_format) {

				$this->af_donat_camp_all_attr_list($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			}

			?>
	</div>
</div>
			<?php
		}


		public function af_donat_camp_onpage_shortcode( $af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format ) {

			if ('table' == $af_don_prod_display_format) {

				$this->af_donat_camp_all_attr_table($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif ('flex' == $af_don_prod_display_format) {

				$this->af_donat_camp_all_attr_flex($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			} elseif ('list' == $af_don_prod_display_format) {

				$this->af_donat_camp_all_attr_list($af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format);
			}
		}


		public function af_donat_camp_all_attr_list( $af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format ) {
			foreach ($af_don_prod_id as $key => $af_rule_id) {
				$check_dont_type  = get_post_meta($af_rule_id, 'af_donat_camp_t', true);
				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_chkout_loc    = get_post_meta($af_rule_id, 'af_chkout_loc', true);
				$af_cart_loc      = get_post_meta($af_rule_id, 'af_cart_loc', true);

				$this->af_donat_camp_multi_disp_list($af_rule_id, $af_donat_prod_is, 'short_code');
			}
		}


		public function af_donat_camp_all_attr_table( $af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format ) {

			foreach ($af_don_prod_id as $key => $af_rule_id) {
				$check_dont_type  = get_post_meta($af_rule_id, 'af_donat_camp_t', true);
				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_chkout_loc    = get_post_meta($af_rule_id, 'af_chkout_loc', true);
				$af_cart_loc      = get_post_meta($af_rule_id, 'af_cart_loc', true);

				$this->af_donat_camp_multi_disp_table($af_rule_id, $af_donat_prod_is, 'short_code');
			}
		}


		public function af_donat_camp_all_attr_flex( $af_don_prod_id, $af_don_prod_display_type, $af_don_prod_display_format ) {

			foreach ($af_don_prod_id as $key => $af_rule_id) {
				$check_dont_type  = get_post_meta($af_rule_id, 'af_donat_camp_t', true);
				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_chkout_loc    = get_post_meta($af_rule_id, 'af_chkout_loc', true);
				$af_cart_loc      = get_post_meta($af_rule_id, 'af_cart_loc', true);

				$this->af_donat_camp_multi_disp_flex($af_rule_id, $af_donat_prod_is, 'short_code');
			}
		}


		public function af_donat_show_camp_all_attr_list( $af_don_prod_display_type, $af_don_prod_display_format ) {

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);
			if ('flex' == $af_don_prod_display_format) {
				?>
<div class="af_donat_main_div_in_flex_">
				<?php
			} elseif ('table' == $af_don_prod_display_format) {
				?>
	<div class="af_donat_main_div_in_popup">
		<table>
			<tr>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[0])) {
					?>
				<td><?php echo esc_html__('Thumbnail', 'af_donation'); ?></td>
					<?php
				}
				?>

				<td> <?php echo esc_html__('Campaign Name', 'af_donation'); ?></td>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[1])) {
					?>
				<td><?php echo esc_html__('Description', 'af_donation'); ?></td>
					<?php
				}
				?>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[2])) {
					?>
				<td><?php echo esc_html__('Causes', 'af_donation'); ?></td>
					<?php
				}
				?>
				<td><?php echo esc_html__('Amount', 'af_donation'); ?></td>
				<td></td>
			</tr>
				<?php

			}

			foreach ($af_wc_donat_rule_id  as $af_don_prod_id) {
				$af_don_prod                 = array();
				$af_don_prod[]               = $af_don_prod_id;
				$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_don_prod_id);
				$af_donat_camp_t             = get_post_meta($af_don_prod_id, 'af_donat_camp_t', true);

				if (empty($af_donat_camp_t)) {
					continue;
				} elseif ('af_dona_fee_base' == $af_donat_camp_t) {
					$af_donat_camp_fee_t = get_post_meta($af_don_prod_id, 'af_donat_camp_fee_t', true);
					if (empty($af_donat_camp_fee_t)) {
						continue;
					}
					if ('af_card_fee' == $af_donat_camp_fee_t) {
						continue;
					}
				}

				$this->af_check_disp_formate($af_don_prod, $af_don_prod_display_type, $af_don_prod_display_format);
			}

			if ('table' == $af_don_prod_display_format) {
				?>
		</table>
				<?php
			}
			?>
	</div>
			<?php
		}


		public function af_donat_rplc_add_crt_btn( $button, $product, $args ) {

			$prod_id             = $product->get_id();
			$af_prod_is_donation = get_post_meta($prod_id, 'af_donation_product', true);

			if (!empty($af_prod_is_donation)) {
				?>
	<form action="<?php echo esc_url(get_permalink($prod_id)); ?>" method="post">
		<input type="submit" name="" value="Donate">
	</form>

				<?php
			} else {
				echo esc_html__($button, 'af_donation');
			}
		}


		public function af_remove_btn_qty_single_prod_page() {

			$af_donation_product = $this->af_product_match_ad_donation();

			if (!empty($af_donation_product)) {

				remove_action('woocommerce_simple_add_to_cart', 'woocommerce_simple_add_to_cart', 30);

				remove_action('woocommerce_subscription_add_to_cart', 'WC_Subscriptions::subscription_add_to_cart', 30);
			} else {
				return;
			}
		}


		public function af_product_match_ad_donation() {
			global $product;

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
				)
			);

			$donat_prod_id = $product->get_id();

			foreach ($af_wc_donat_rule_id  as $value) {
				$af_donat_rule_       = get_post_meta($value, 'af_rule_as_prod', true);
				$af_donat_camp_t      = get_post_meta($value, 'af_donat_camp_t', true);
				$af_slct_disp_typ_bar = get_post_meta($value, 'af_slct_disp_typ_bar', true);
				$af_donat_choice      = get_post_meta($value, 'af_donat_choice', true);

				if ($af_donat_rule_ == $donat_prod_id) {

					if ('af_dona_prod_base' == $af_donat_camp_t) {

						$af_define_donat_choice = get_post_meta($value, 'af_define_donat_choice', true);
						if ('af_ena_recu' == $af_donat_choice) {
							if ('af_define_recu' == $af_define_donat_choice) {
								return false;
							}
							if ('af_customer_recu' == $af_define_donat_choice) {
								return true;
							}
						}
						$af_donat_choice = get_post_meta($value, 'af_donat_choice', true);

						if ('af_dis_recu' == $af_donat_choice) {
							return true;
						}
					}
					return true;
				}
			}
			return false;
		}


		public function af_donat_rplc_add_crt_btn_prod_page() {

			global $product;

			$prod_id = $product->get_id();

			$af_prod_is_donation = get_post_meta($prod_id, 'af_donation_product', true);

			if (!empty($af_prod_is_donation)) {

				echo esc_html__('Donate', 'af_donation');
			} else {
				echo esc_html__('Add to cart', 'af_donation');
			}
		}


		public function af_donat_define_opt_on_subs_prod_page() {
			global $product, $af_gonate_prod_id;

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			$donat_prod_id = $product->get_id();

			$af_donat_rule_ = get_post_meta($product->get_id(), 'af_donation_product_rule', true);

			foreach ($af_wc_donat_rule_id  as $value) {

				if ($af_donat_rule_ == $value) {

					$af_donat_choice        = get_post_meta($value, 'af_donat_choice', true);
					$af_donat_camp_t        = get_post_meta($value, 'af_donat_camp_t', true);
					$af_define_donat_choice = get_post_meta($value, 'af_define_donat_choice', true);
					$af_define_donat_choice = get_post_meta($af_donat_rule_, 'af_define_donat_choice', true);

					if ('af_ena_recu' == $af_donat_choice && 'af_dona_prod_base' == $af_donat_camp_t ) {

						if ('af_define_recu' == $af_define_donat_choice) {

							$this->af_dont_disp_caus_on_prod_page($af_donat_rule_);
						}
					}
				}
			}
		}


		public function af_donat_opt_on_subs_prod_page() {

			global $product, $af_gonate_prod_id;

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			$donat_prod_id = $product->get_id();

			$af_donat_rule_ = get_post_meta($product->get_id(), 'af_donation_product_rule', true);

			foreach ($af_wc_donat_rule_id  as $value) {

				if ($af_donat_rule_ == $value) {

					$af_donat_choice        = get_post_meta($value, 'af_donat_choice', true);
					$af_define_donat_choice = get_post_meta($value, 'af_define_donat_choice', true);
					$af_define_donat_choice = get_post_meta($af_donat_rule_, 'af_define_donat_choice', true);
					$af_donat_camp_t        = get_post_meta($value, 'af_donat_camp_t', true);
					
					if ('af_ena_recu' == $af_donat_choice && 'af_dona_prod_base' == $af_donat_camp_t ) {

						if ('af_define_recu' == $af_define_donat_choice) {
							continue;
						}

						?>
	<form method="post">

						<?php
							$this->af_dont_disp_amt_optn_sub_pro($af_donat_rule_, $donat_prod_id);

							$af_time_period   = array( 'day', 'week', 'month', 'year' );
							$af_interval      = 6;
							$af_interval_chek = 2;
						?>
		<div class="af_donat_rec_prod_page">
			<select class="af_donat_sub_other af_dont_inter" name="af_sub_period_interval">
				<option value="1"><?php echo esc_html__('every ', 'af_donation'); ?></option>
						<?php
						while ($af_interval_chek <= $af_interval) {
							?>
				<option value="<?php echo esc_attr($af_interval_chek); ?>">
							<?php echo esc_html__('every ' . $af_interval_chek . 'th', 'af_donation'); ?></option>
							<?php
							++$af_interval_chek;
						}
						?>
			</select>
			<select name="af_sub_period" class="af_admin_recu_lnght af_donat_sub_other">
						<?php
						foreach ($af_time_period as $key => $value) {

							?>
				<option value="<?php echo esc_attr($value); ?>"><?php echo esc_html__($value, 'af_donation'); ?>
				</option>
							<?php

						}
						?>
			</select>

			<input type="number" name="af_dont_lngt" class="af_donat_sub_other" id="af_donat_sub_other">
						<?php

								$this->af_dont_disp_caus_on_prod_page($af_donat_rule_);
						?>

			<button type="submit" name="af_donat_sub_prod"
				class="single_add_to_cart_button af_dont_btn_chk af_dont_btn_chk button alt">
						<?php
						if (!empty(get_option('af_dona_btn_txt'))) {
							echo esc_html__(get_option('af_dona_btn_txt'), 'af_donation');
						} else {
								echo esc_html__('Donate', 'af_donation');
						}
						?>
			</button>
		</div>
	</form>
						<?php
					}
				}
			}
		}


		public function af_sub_prod_opts( $af_donat_rule ) {

			$af_time_period   = array( 'day', 'week', 'month', 'year' );
			$af_interval      = 6;
			$af_interval_chek = 2;
			?>
	<select
		class="af_donat_amt_popup_selct af_donat_peri_popup_selct<?php echo esc_attr($af_donat_rule); ?> af_dont_inter"
		name="af_sub_period_interval">
		<option value="1"><?php echo esc_html__('every ', 'af_donation'); ?></option>
			<?php
			while ($af_interval_chek <= $af_interval) {
				?>
		<option value="<?php echo esc_attr($af_interval_chek); ?>">
				<?php echo esc_html__('every ' . $af_interval_chek . 'th', 'af_donation'); ?></option>
				<?php
					++$af_interval_chek;
			}
			?>
	</select>
	<select name="af_sub_period"
		class="af_admin_recu_lnght af_donat_amt_popup_selct af_admin_recu_lnght<?php echo esc_attr($af_donat_rule); ?>">
			<?php
			foreach ($af_time_period as $key => $value) {
				?>
		<option value="<?php echo esc_attr($value); ?>"><?php echo esc_html__($value, 'af_donation'); ?></option>
				<?php

			}
			?>
	</select>
	<input type="number" name="af_dont_lngt"
		class="af_donat_sub_other af_donat_other_lngt<?php echo esc_attr($af_donat_rule); ?>" id="af_donat_sub_other">
			<?php
		}


		public function af_dont_disp_amt_optn_sub_pro( $af_donat_rule_, $donat_prod_id ) {
			$get_table_count     = get_post_meta($af_donat_rule_, 'get_table_count', true);
			$af_enble_other_optn = get_post_meta($af_donat_rule_, 'af_enble_other_optn', true);
			$af_min_donat_amt    = get_post_meta($af_donat_rule_, 'af_min_donat_amt', true);
			$af_donat_goal_amot  = get_post_meta($af_donat_rule_, 'af_donat_goal_amot', true);
			$af_max_donat_amt    = get_post_meta($af_donat_rule_, 'af_max_donat_amt', true);
			$af_amt_type         = get_post_meta($af_donat_rule_, 'af_amt_type', true);
			$af_show_other_optn  = get_post_meta($af_donat_rule_, 'af_show_other_optn', true);
			$af_amt_opt_type     = get_post_meta($af_donat_rule_, 'af_amt_opt_type', true);

			if (!empty($af_amt_opt_type) || !empty($af_enble_other_optn)) { 
				?>

				<h3 class="af-select-amount-label"><?php echo esc_html__('Custom Amount', 'af_donation'); ?></h3>
			
			<?php } ?>

			<div class="af_donat_amt_opt_main">
				<div class="af_donat_amt_opt_rows">
					<div class="af_donat_amt_opt_row1">
						<input type="hidden" name="af_donat_prod_id" value="<?php echo esc_attr($donat_prod_id); ?>">
						<?php

							$af_gonate_prod_id = $donat_prod_id;

						if (!empty($af_amt_opt_type)) {

							for ($i = 1; $i <= $get_table_count; $i++) {

								$af_dont_leve_lbl = get_post_meta($af_donat_rule_, 'af_donat_text' . $i, true);

								$af_dont_leve_val = get_post_meta($af_donat_rule_, 'af_donat_number' . $i, true);
									
								if (!empty($af_dont_leve_lbl)) { 
									?>

										<div class="af_donat_amt_opt_row1_btn">

											<input type="radio" name="af_slct_lvl_optn" class="af_show_amout_lbl"
												id="<?php echo esc_attr($af_dont_leve_val); ?>"
												value="<?php echo esc_attr($af_dont_leve_val); ?>">

											<label class="af_amt_front_lbl wc-active" for="<?php echo esc_attr($af_dont_leve_val); ?>">
												<?php echo esc_html__($af_dont_leve_lbl, 'af_donation'); ?>
											</label>

										</div>

									<?php
								}
							}
						}

						if ('yes' == $af_enble_other_optn) {

							if ('pre_define' == $af_amt_type) {

								$af_min_donat_amt = 0;

								if (!empty($af_donat_goal_amot)) {

									$af_max_donat_amt = $af_donat_goal_amot;

									$af_min_donat_amt = 0;

								}

							} elseif ('custome_value' == $af_amt_type) {

								$af_max_donat_amt = $af_max_donat_amt;

								$af_min_donat_amt = $af_min_donat_amt;

							}

							if ('af_show_in_optn' == $af_show_other_optn) { 
								?>

								<div class="af_donat_amt_opt_row1_btn">
								
									<input type="radio" name="af_slct_lvl_optn" class="af_show_amout_lbl"
										id="<?php echo esc_attr('af_other_amount'); ?>"
										value="<?php echo esc_attr('af_other_amount'); ?>">

									<label class="af_amt_front_lbl" for="<?php echo esc_attr('af_other_amount'); ?>"><?php echo esc_html__('Other amount', 'af_donation'); ?></label>

									<?php 
									if ('yes' == $af_enble_other_optn) {

										$product_id = get_post_meta($af_donat_rule_, 'af_rule_as_prod', true);

										$donated_amount = 0;

										$all_order = wc_get_orders(

											array(

												'type' => 'shop_order',

											)

										);

										foreach ($all_order as $key => $value) {

											foreach ($value->get_items() as $key => $pro_item) {

												if ($product_id == $pro_item->get_product_id()) {

													$donated_amount += $pro_item->get_subtotal();
												}
											}
										}

										if (empty($af_min_donat_amt)) {

											$af_min_donat_amt = 1;

										} 
										?>

										<div class="af_donat_other_optn">
											<input type="number" name="af_other_input" min="5" max="<?php echo esc_attr($af_max_donat_amt); ?>"
												class="af_donat_other<?php echo esc_attr($af_donat_rule_); ?> af_donat_other"
												placeholder="<?php echo esc_html__($af_min_donat_amt . '-' . $af_max_donat_amt, 'af_donation'); ?>">
										</div>

									<?php } ?>

								</div>
							
								<?php

							}

						}

							$af_donat_camp_fee_t = get_post_meta($af_donat_rule_, 'af_donat_camp_fee_t', true);
						
						?>

					</div>
					
				</div>

			</div>

			<?php
		}


		public function af_dont_disp_caus_on_prod_page( $af_donat_rule_ ) {

			$af_don_compaign_causes = get_post_meta($af_donat_rule_, 'af_don_compaign_causes', true);

			if (!empty($af_don_compaign_causes)) { 
				?>
				
				<h3 class="af-select-amount-label"><?php echo esc_html__('Causes', 'af_donation'); ?></h3>
				
			<?php } ?>

			<div class="af_donat_amt_opt_main">
				<div class="af_donat_amt_opt_rows">
					<div class="af_donat_cause_optn_row1">

					<?php 
					if (!empty($af_don_compaign_causes) && isset( $af_don_compaign_causes['name'] ) ) {

						$i = 0;

						foreach ( $af_don_compaign_causes['name'] as $index => $value ) {

							++$i;

							$image_url      = isset( $af_don_compaign_causes['img'][ $index ] ) ? $af_don_compaign_causes['img'][ $index ] : '';
							$af_cause_name  = isset( $af_don_compaign_causes['name'][ $index ] ) ? $af_don_compaign_causes['name'][ $index ] : '';
							$af_cause_descp = isset( $af_don_compaign_causes['description'][ $index ] ) ? $af_don_compaign_causes['description'][ $index ] : '';
							?>

						<div class="af_dont_cause_optn">
							<input class="af_cause_option" value="<?php echo esc_html__($af_cause_name, 'af_donation'); ?>"
								type="radio" name="af_cause_option">

							<div class="af_caue_description">
								<img class="af_cause_image" src="<?php echo esc_url($image_url); ?>">
								<h3 type="text" class="af_cause_name_prod" name="af_cause_name<?php echo esc_attr($i); ?>">
									<?php echo esc_html__($af_cause_name, 'af_donation'); ?></h3>
								<p class="af_cause_desp_prod" name="af_cause_descp<?php echo esc_attr($i); ?>">
									<?php echo esc_html__($af_cause_descp, 'af_donation'); ?></p>
							</div>

						</div>

							<?php

						}

					} 
					?>
					</div>
				</div>
			</div>

			<?php
		}


		public function af_donat_opt_on_prod_page() {
			global $product, $af_gonate_prod_id;

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			$donat_prod_id = $product->get_id();

			$af_donat_rule_ = get_post_meta($product->get_id(), 'af_donation_product_rule', true);

			$rule_post = get_post( $af_donat_rule_ );

			if ( is_a( $rule_post, 'WP_Post' ) ) {
				$this->af_donat_call_donat_rule_options( $donat_prod_id, $af_donat_rule_);
			}
		}

		public function af_donat_call_donat_rule_options( $donat_prod_id, $af_donat_rule_ ) {

			$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_donat_rule_);

			if ( get_post_meta($af_donat_rule_, 'af_donatio_close', true ) ) {
				echo wp_kses_post( get_post_meta( $af_donat_rule_, 'af_donat_close_msg', true ) );
				return;
			}

			if ('false' == $af_check_donat_goal_setting) {

				return;
			} elseif (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {
				$this->af_donation_close_msg($af_check_donat_goal_setting['close_donation']);
				update_post_meta($af_donat_rule_, 'af_donatio_close', 'close');

				if ('' == get_post_meta($af_donat_rule_, 'af_donatio_close_date', true)) {

					update_post_meta($af_donat_rule_, 'af_donatio_close_date', gmdate('Y-m-d'));
				}
			} else {

				$af_donat_goal_amot = get_post_meta($af_donat_rule_, 'af_donat_goal_amot', true);

				$get_table_count = get_post_meta($af_donat_rule_, 'get_table_count', true);

				$af_enble_other_optn = get_post_meta($af_donat_rule_, 'af_enble_other_optn', true);

				$af_chk_dont_typ = get_post_meta($af_donat_rule_, 'af_donat_camp_t', true);

				$af_donat_choice = get_post_meta($af_donat_rule_, 'af_donat_choice', true);

				$af_define_donat_choice = get_post_meta($af_donat_rule_, 'af_define_donat_choice', true);

				$af_show_other_optn = get_post_meta($af_donat_rule_, 'af_show_other_optn', true);

				?>
	<input type="hidden" class="af_show_optn" name="" value="<?php echo esc_attr($af_show_other_optn); ?>">

	<form method="post">

				<?php
				if ('af_ena_recu' == $af_donat_choice) {

						return;
				}

				if ('af_dona_prod_base' == $af_chk_dont_typ) {

							$this->af_dont_disp_amt_optn_sub_pro($af_donat_rule_, $donat_prod_id);

							$this->af_dont_disp_caus_on_prod_page($af_donat_rule_);
					?>
		<!-- product base button -->
		<div class="af_donat_amt_opt_row2">
			<br>
					<?php
					if ('af_dona_fee_base' == $af_chk_dont_typ) {
						?>
			<button type="submit" name="af_donat_fee_donat" value="<?php echo esc_attr($donat_prod_id); ?>"
				class="single_add_to_cart_button af_dont_btn_chk button alt">
						<?php
						if (!empty(get_option('af_dona_btn_txt'))) {
									echo esc_html__(get_option('af_dona_btn_txt'), 'af_donation');
						} else {
										echo esc_html__('Donate', 'af_donation');
						}
						?>
			</button>
							<?php
					} else {
						?>
			<button type="submit" name="af_donat_prod_donat" value="<?php echo esc_attr($donat_prod_id); ?>"
				class="af_dont_btn_chk single_add_to_cart_button af_dont_btn_chk button alt">
						<?php
						if (!empty(get_option('af_dona_btn_txt'))) {
									echo esc_html__(get_option('af_dona_btn_txt'), 'af_donation');
						} else {
										echo esc_html__('Donate', 'af_donation');
						}
						?>
			</button>
							<?php
					}
					?>

		</div>
					<?php
				}
				?>
	</form>
				<?php
			}
		}

		public function af_donate_progress_bar() {

			$af_donation_product = $this->af_product_match_ad_donation();

			if (!empty($af_donation_product)) {
				$this->af_donat_progres_status();
			} else {
				return;
			}
		}

		public function af_donat_progres_status() {
			global $product;

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			$donat_prod_id      = $product->get_id();
			$donated_amount     = 0;
			$donated_count      = 0;
			$af_donat_goal_amot = 0;
			$af_donat_rule_     = get_post_meta($product->get_id(), 'af_donation_product_rule', true);

			$af_donat_enable_goal =  get_post_meta($af_donat_rule_, 'af_donat_enable_goal', true);

			if ( 'af_enab_goal' != $af_donat_enable_goal ) {
				return;
			}

			foreach ($af_wc_donat_rule_id  as $value) {

				if ($af_donat_rule_ == $value) {

					$af_donat_rule_       = get_post_meta($product->get_id(), 'af_donation_product_rule', true);
					$af_donat_goal_amot   = get_post_meta($af_donat_rule_, 'af_donat_goal_amot', true);
					$af_wc_goal_type_name = get_post_meta($af_donat_rule_, 'af_wc_goal_type_name', true);
					$af_no_of_days_donat  = get_post_meta($af_donat_rule_, 'af_no_of_days_donat', true);
					$af_slct_disp_typ_bar = get_post_meta($value, 'af_slct_disp_typ_bar', true);

					$all_order = wc_get_orders(
						array(
							'type' => 'shop_order',
						)
					);

					foreach ($all_order as $key => $value) {

						foreach ($value->get_items() as $key => $pro_item) {

							if ($product->get_id() == $pro_item->get_product_id()) {
								++$donated_count;
								$donated_amount += $pro_item->get_subtotal();
							}
						}
					}

					if ('amount' == $af_slct_disp_typ_bar) {

						if (!empty($af_donat_goal_amot)) {
							$donated_amt_in_per = ( $donated_amount / $af_donat_goal_amot ) * 100;
						}
						$donated_amt_in_per = number_format($donated_amt_in_per, 2);
						$af_donated_price   =  wc_price($donated_amount);
					} elseif ('percentage' == $af_slct_disp_typ_bar) {

						if (!empty($af_donat_goal_amot)) {
							$donated_amt_in_per = ( $donated_amount / $af_donat_goal_amot ) * 100;
						}
						$donated_amt_in_per = number_format($donated_amt_in_per, 2);
						$af_donated_price   = $donated_amt_in_per . '%';
					} elseif ('Donat_no' == $af_slct_disp_typ_bar) {

						if (!empty($af_donat_goal_amot)) {
							$donated_amt_in_per = ( $donated_amount / $af_donat_goal_amot ) * 100;
						}
						$donated_amt_in_per = number_format($donated_amt_in_per, 2);


						$af_donated_price = $donated_count;
					} else {
						return;
					}

					if ('100' < $donated_amt_in_per) {
						$donated_amt_in_per = 100;
					}
					?>
	<div class="af_donat_progress_main">
		<div class="af_donat_progress_line" style="width: <?php echo esc_attr($donated_amt_in_per . '%'); ?>">
			<label id="af_prog_lbl"><?php echo wp_kses_post($af_donated_price); ?></label>
		</div>
	</div>
	<div class="af_donat_progress_detail">
		<label><?php echo wp_kses_post(wc_price(0)); ?></label>
		<label id="af_prog_lbl"><?php echo wp_kses_post(wc_price($af_donat_goal_amot)); ?></label>
	</div>
					<?php
				}
			}
		}

		public function af_donat_camp_goal_setting( $af_donat_rule_ ) {

			$af_donat_camp_goal_setting_optn = $this->af_donat_camp_goal_setting_optn($af_donat_rule_);

			$af_donat_enable_goal =  get_post_meta($af_donat_rule_, 'af_donat_enable_goal', true);

			if ( 'af_enab_goal' != $af_donat_enable_goal ) {
				return;
			}

			if (in_array('amt_raisd', $af_donat_camp_goal_setting_optn)) {

				$af_donat_goal_amot    = get_post_meta($af_donat_rule_, 'af_donat_goal_amot', true);
				$product_id            = get_post_meta($af_donat_rule_, 'af_rule_as_prod', true);
				$donated_amount        = 0;
				$product_id            = get_post_meta($af_donat_rule_, 'af_rule_as_prod', true);
				$af_fee_amount_donated = get_post_meta($af_donat_rule_, 'af_donat_amt_on_camp_fee', true);


				$af_chk_dont_typ = get_post_meta($af_donat_rule_, 'af_donat_camp_t', true);

				$all_order = wc_get_orders(
					array(
						'type' => 'shop_order',
					)
				);

				if ('af_dona_fee_base' == $af_chk_dont_typ) {
					$donated_amount = $af_fee_amount_donated;
				} else {

					foreach ($all_order as $key => $af_order) {
						foreach ($af_order->get_items() as $key => $pro_item) {

							if ($product_id == $pro_item->get_product_id()) {
								$donated_amount += $pro_item->get_subtotal();
							}
						}
					}
				}

				if ( 'af_enab_goal' == $af_donat_enable_goal && $donated_amount >= $af_donat_goal_amot) {
					return array( 'close_donation' => $af_donat_camp_goal_setting_optn['close_msg'] );
				}
			} elseif (in_array('no_of_donat', $af_donat_camp_goal_setting_optn)) {

				$af_donat_number     = $af_donat_camp_goal_setting_optn['no_donat_and_day'];
				$af_no_of_days_donat = get_post_meta($af_donat_rule_, 'af_no_of_days_donat', true);
				$af_chk_dont_typ     = get_post_meta($af_donat_rule_, 'af_donat_camp_t', true);
				$af_check_fe_count   = get_post_meta($af_donat_rule_, 'af_donat_count_camp_fee', true);
				$donated_number      = 0;
				$product_id          = get_post_meta($af_donat_rule_, 'af_rule_as_prod', true);

				$all_order = wc_get_orders(
					array(
						'type' => 'shop_order',
					)
				);

				if ('af_dona_fee_base' == $af_chk_dont_typ) {
					$donated_number = $af_check_fe_count;
				} else {

					foreach ($all_order as $key => $af_order) {
						foreach ($af_order->get_items() as $key => $pro_item) {
							if ($product_id == $pro_item->get_product_id()) {
								++$donated_number;
							}
						}
					}
				}

				if ( 'af_enab_goal' == $af_donat_enable_goal && $donated_number >= $af_no_of_days_donat) {
					return array( 'close_donation' => $af_donat_camp_goal_setting_optn['close_msg'] );
				}

			} elseif (in_array('no_of_days', $af_donat_camp_goal_setting_optn)) {

				$af_no_of_days_donat = get_post_meta($af_donat_rule_, 'af_no_of_days_donat', true);
				$cur_date            = gmdate('Y-m-d');
				$rul_publ_date       = get_the_time('Y-m-d', $af_donat_rule_);
				$later               = new DateTime($cur_date);
				$earlier             = new DateTime($rul_publ_date);
				$check_no_days       = $earlier->diff($later)->format('%r%a');

				if ($check_no_days > $af_no_of_days_donat) {
					return array( 'close_donation' => $af_donat_camp_goal_setting_optn['close_msg'] );
				}

			} elseif (in_array('goal_end_date', $af_donat_camp_goal_setting_optn)) {

				if (!empty($af_donat_camp_goal_setting_optn['donat_end_date'])) {
					if (gmdate('Y-m-d') > $af_donat_camp_goal_setting_optn['donat_end_date']) {
						return array( 'close_donation' => $af_donat_camp_goal_setting_optn['close_msg'] );
					}
				}
				
			}
		}

		public function af_donat_camp_goal_setting_optn( $af_donat_rule_ ) {

			$af_donat_enable_goal = get_post_meta($af_donat_rule_, 'af_donat_enable_goal', true);

			$af_donat_goal_amot = get_post_meta($af_donat_rule_, 'af_donat_goal_amot', true);

			$af_donat_close_msg = get_post_meta($af_donat_rule_, 'af_donat_close_msg', true);

			$af_donatio_close = get_post_meta($af_donat_rule_, 'af_donatio_close', true);

			$af_donat_end_date = get_post_meta($af_donat_rule_, 'af_donat_end_date', true);

			$af_donat_end_type = get_post_meta($af_donat_rule_, 'af_donat_end_type', true);

			$af_no_of_days_donat = get_post_meta($af_donat_rule_, 'af_no_of_days_donat', true);

			$af_camp_goal_data = array(
				'goal_amount'      => $af_donat_goal_amot,
				'donat_end_date'   => 'close' == $af_donatio_close ? $af_donat_end_date : '',
				'close_msg'        => $af_donat_close_msg,
				'end_goal_type'    => $af_donat_end_type,
				'no_donat_and_day' => $af_no_of_days_donat,
			);

			return $af_camp_goal_data;
		}

		public function af_donation_close_msg( $af_donation_msg ) {
			?>
			<h2> <?php echo esc_html__($af_donation_msg, 'af_donation'); ?> </h2>
			<?php
		}

		public function af_donat_prod_page_btn() {

			if (!class_exists('WC_Email', false)) {
				include_once dirname(WC_PLUGIN_FILE) . '/includes/emails/class-wc-email.php';
			}

			global $af_gonate_prod_id, $af_donat_price, $donate_cause;

			if (isset($_POST['af_other_input'])) {
				$af_donat_price = sanitize_text_field($_POST['af_other_input']);
			}

			if (isset($_POST['af_donat_nonce'])) {
				$nonce = sanitize_text_field(wp_unslash($_POST['af_donat_nonce']));
				if (!wp_verify_nonce($nonce, '_wpnonce')) {

					die('Failed security check!');
				}
			}

			if (isset($_POST['af_cause_option'])) {
				$donate_cause = sanitize_text_field($_POST['af_cause_option']);
			}

			if (isset($_POST['af_sub_period_interval'])) {
				$af_sub_period_interval = sanitize_text_field($_POST['af_sub_period_interval']);
			}

			if (isset($_POST['af_sub_period'])) {
				$af_sub_period = sanitize_text_field($_POST['af_sub_period']);
			}

			if (isset($_POST['af_dont_lngt'])) {
				$af_dont_lngt = sanitize_text_field($_POST['af_dont_lngt']);
			}

			if (isset($_POST['af_donat_sub_prod'])) {

				if (isset($_POST['af_donat_prod_id'])) {
					$donat_prod_id = sanitize_text_field($_POST['af_donat_prod_id']);
				}
				$product        = wc_get_product($donat_prod_id);
				$af_donat_price = $product->get_price();

				$donat_prod_name = $product->get_title();
				$donat_prod_id   = sanitize_text_field($_POST['af_donat_prod_id']);

				if (!empty($_POST['af_slct_lvl_optn'])) {
					$af_slct_lvl_optn = sanitize_text_field($_POST['af_slct_lvl_optn']);
				}

				if (!empty($_POST['af_other_input']) || !empty($af_slct_lvl_optn)) {

					if (!empty($_POST['af_other_input'])) {
						$af_donat_price = sanitize_text_field($_POST['af_other_input']);
					}

					if (!empty($af_slct_lvl_optn)) {
						$af_donat_price = $af_slct_lvl_optn;
					}

					$af_sub_interval_opt = array(
						'subscription_donation'        => $donat_prod_name,
						'donation_cause'               => $donate_cause,
						'donation_amount'              => $af_donat_price,
						'subscription_period'          => $af_sub_period,
						'subscription_period_interval' => $af_sub_period_interval,
						'subscription_length'          => $af_dont_lngt,
					);


					if (WC()->cart->add_to_cart($donat_prod_id, 1, 0, array(), $af_sub_interval_opt)) {

						if (!is_cart()) {
							$af_noti_msg      =  get_option('af_donat_notify_msg_editor_id');
							$notification_msg = str_replace('{campaign_name}', $donat_prod_name, $af_noti_msg);
							wc_add_notice(esc_html__($notification_msg, 'af_donation') . '<a class="button wc-forward" href="' . esc_url(wc_get_cart_url()) . '">' . esc_html__('View cart', 'af_donation') . '  </a>', 'success');
						}
					}
				}
			}

			if (isset($_POST['af_donat_prod_donat'])) {

				if (!empty($_POST['af_donat_prod_id'])) {

					$donat_prod_id  = sanitize_text_field($_POST['af_donat_prod_id']);
					$product        = wc_get_product($donat_prod_id);
					$af_donat_price = $product->get_price();

					$donat_prod_name = $product->get_title();

					$post_url          = get_permalink($donat_prod_id);
					$af_gonate_prod_id = $donat_prod_id;
					if (!empty($_POST['af_other_input'])) {
						$af_donat_price = sanitize_text_field($_POST['af_other_input']);

						if (WC()->cart->add_to_cart($donat_prod_id, 1, 0, array(), array(
							'donation'        => $donat_prod_name,
							'donation_cause'  => $donate_cause,
							'donation_amount' => $af_donat_price,
						))) {

							if (!is_cart()) {
								$af_noti_msg      =  get_option('af_donat_notify_msg_editor_id');
								$notification_msg = str_replace('{campaign_name}', $donat_prod_name, $af_noti_msg);

								wc_add_notice(esc_html__($notification_msg, 'af_donation') . '<a class="button wc-forward" href="' . esc_url(wc_get_cart_url()) . '"> View cart </a>', 'success');
							}
						}
					} elseif (!empty($_POST['af_slct_lvl_optn'])) {
						$af_donat_price = sanitize_text_field($_POST['af_slct_lvl_optn']);


						if (WC()->cart->add_to_cart($donat_prod_id, 1, 0, array(), array(
							'donation'        => $donat_prod_name,
							'donation_cause'  => $donate_cause,
							'donation_amount' => $af_donat_price,
						))) {

							if (!is_cart()) {
								$af_noti_msg      =  get_option('af_donat_notify_msg_editor_id');
								$notification_msg = str_replace('{campaign_name}', $donat_prod_name, $af_noti_msg);
								wc_add_notice(esc_html__($notification_msg, 'af_donation') . '<a class="button wc-forward" href="' . esc_url(wc_get_cart_url()) . '">' . esc_html__('View cart', 'af_donation') . '  </a>', 'success');
							}
						}
					} elseif (WC()->cart->add_to_cart($donat_prod_id, 1, 0, array(), array(
						'donation'        => $donat_prod_name,
						'donation_cause'  => $donate_cause,
						'donation_amount' => $af_donat_price,
					))) {

						if (!is_cart()) {
							$af_noti_msg      =  get_option('af_donat_notify_msg_editor_id');
							$notification_msg = str_replace('{campaign_name}', $donat_prod_name, $af_noti_msg);
							wc_add_notice(esc_html__($notification_msg, 'af_donation') . '<a class="button wc-forward" href="' . esc_url(wc_get_cart_url()) . '">' . esc_html__('View cart', 'af_donation') . '  </a>', 'success');
						}
					}
				}
			}
			$af_check_fee_in_sess = array();

			if (!empty($_POST['af_other_input'])) {
				$af_donat_price = sanitize_text_field($_POST['af_other_input']);
			} elseif (isset($_POST['af_cause_option'])) {

					$donate_cause = sanitize_text_field($_POST['af_cause_option']);

				if (isset($_POST['af_donat_fee'])) {

					$af_check_fee_in_sess = (array) WC()->session->get('af_done_fee_in_cart');
					$af_donat_price       = sanitize_text_field($_POST['af_donat_fee']);

					$af_check_fee_in_sess[] = array(
						'fee_name'   => $donate_cause,
						'fee_amount' => $af_donat_price,
					);
					WC()->session->set('af_done_fee_in_cart', $af_check_fee_in_sess);
				}
			}
		}


		public function af_my_add_bacs_fee( $cart ) {

			$af_check_fee_in_sess = (array) WC()->session->get('af_done_fee_in_cart');
			if (!empty($af_check_fee_in_sess)) {

				foreach ($af_check_fee_in_sess as $key => $value) {

					if (!empty($value['fee_name']) && !empty($value['fee_amount']) && is_numeric($value['fee_amount'])) {

						$donate_cause   = $value['fee_name'];
						$af_donat_price = $value['fee_amount'];

						if (!empty($donate_cause) && !empty($af_donat_price)) {
							WC()->cart->add_fee($donate_cause, $af_donat_price);
						}
					}
				}
			}
		}


		public function af_donat_add_rule_id_to_cart( $cart_data, $cart_item ) {
			global $af_gonate_prod_id, $af_donat_price, $donate_cause;

			if (isset($_POST['af_donat_nonce'])) {
				$nonce = sanitize_text_field(wp_unslash($_POST['af_donat_nonce']));
				if (!wp_verify_nonce($nonce, '_wpnonce')) {

					die('Failed security check!');
				}
			}

			if (!empty($cart_data['donation'])) {

				$cart_data['donat_product']       = $af_gonate_prod_id;
				$cart_data['donat_product_price'] = $af_donat_price;
			}

			if (!empty($_POST['af_cause_option'])) {
				$cart_data['donat_cause'] = sanitize_text_field($_POST['af_cause_option']);
			}

			return $cart_data;
		}


		public function af_donat_set_prod_price( $cart_object ) {
			global $af_donat_price;

			foreach ($cart_object->get_cart() as $hash => $value_cart) {

				if (!empty($value_cart['donation']) || !empty($value_cart['donation_amount'])) {

					if (!empty($value_cart['donation']) || !empty($value_cart['donation_amount'])) {

						if (!empty($value_cart['donation_amount'])) {
							$custom_price = floatval($value_cart['donation_amount']);
						}

						if (empty($custom_price) && empty($cart_object->cart_contents[ $hash ]['data']->get_price())) {
							$custom_price = 1;
						} elseif (empty($custom_price) && !empty($cart_object->cart_contents[ $hash ]['data']->get_price())) {
							$custom_price = $cart_object->cart_contents[ $hash ]['data']->get_price();
						}

						$cart_object->cart_contents[ $hash ]['data']->set_price($custom_price);
						$value_cart['data']->set_price($custom_price);
					}
				}

				if (!empty($value_cart['subscription_donation']) || !empty($value_cart['subscription_period'])) {

					foreach ($value_cart['data']->get_meta_data() as $key => $meta_data) {

						if ('_subscription_period' == $meta_data->get_data()['key']) {

							$meta_data->__set('value', $value_cart['subscription_period']);
							$meta_data->apply_changes();
						}
						if ('_subscription_period_interval' == $meta_data->get_data()['key']) {

							$meta_data->__set('value', $value_cart['subscription_period_interval']);
							$meta_data->apply_changes();
						}
						if ('_subscription_length' == $meta_data->get_data()['key']) {

							$meta_data->__set('value', $value_cart['subscription_length']);

							$meta_data->apply_changes();
						}
						if ('_subscription_price' == $meta_data->get_data()['key']) {
							$meta_data->__set('value', $value_cart['donation_amount']);
							$custom_price = floatval($value_cart['donation_amount']);
							if (empty($value_cart['donation_amount'])) {
								$custom_price = 1;
							}
							$cart_object->cart_contents[ $hash ]['data']->set_price($custom_price);
							$meta_data->apply_changes();
						}
					}
				}
			}
		}


		public function af_donat_set_price_mini_cart( $price, $cart_item, $cart_item_key ) {

			if (!empty($cart_item['donation_amount'])) {
				$price = wp_kses_post(wc_price($cart_item['donation_amount']));
			}
			return $price;
		}


		public function af_donat_cart_prod_cause_title( $item_data, $cart_item ) {

			if (!empty($cart_item['donation_cause'])) {

				$item_data[] = array(
					'name'  => 'Cause',
					'value' => $cart_item['donation_cause'],
				);
			}
			return $item_data;
		}

		public function af_donat_add_meta_for_cause( $item, $cart_item_key, $values, $order ) {

			if (!empty($values['donation_cause'])) {
				$item->update_meta_data('Cause', $values['donation_cause']);
			}
		}


		public function af_donat_optn_show_chkout() {
			$af_check_chkout     = 'false';
			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);
			foreach ($af_wc_donat_rule_id as $key => $af_check) {
				$af_chkout_loc = get_post_meta($af_check, 'af_chkout_loc', true);
				if (!empty($af_chkout_loc)) {
					$af_check_chkout = 'true';
				}
			}

			if ('false' == $af_check_chkout) {
				return;
			}

			if ('on_page' == get_option('af_dona_chkt_disp_opt')) {



				$check_on_cart = 'false';
				foreach ($af_wc_donat_rule_id as $key => $af_campgns) {
					$af_chkout_loc       = get_post_meta($af_campgns, 'af_chkout_loc', true);
					$af_donat_camp_fee_t = get_post_meta($af_campgns, 'af_donat_camp_fee_t', true);
					if ('af_card_fee' == $af_donat_camp_fee_t) {
						continue;
					}
					if (empty($af_chkout_loc)) {
						continue;
					} else {
						$check_on_cart = 'true';
					}
				}
				if ('false' == $check_on_cart) {
					return;
				}
				?>
	<div class="af_all_campaings_chkout">
		<div class="af_donat_select_chk_div">
			<div class="af_donat_select_chk_div_left">
				<label><?php echo esc_html__(get_option('af_chkt_page_hadng'), 'af_donation'); ?></label>
			</div>
			<div class="af_donat_select_chk_div_right">
				<select class="af_select_camp_on_chkt">
					<?php
					foreach ($af_wc_donat_rule_id as $key => $af_campgns) {

						$af_chkout_loc        = get_post_meta($af_campgns, 'af_chkout_loc', true);
						$af_donat_camp_fee_t  = get_post_meta($af_campgns, 'af_donat_camp_fee_t', true);
						$af_donat_enable_goal = get_post_meta($af_campgns, 'af_donat_enable_goal', true);

						$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_campgns);

						if ('false' == $af_check_donat_goal_setting) {

							return;
						} elseif (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {

							$this->af_donation_close_msg($af_check_donat_goal_setting['close_donation']);
							update_post_meta($af_campgns, 'af_donatio_close', 'close');
							continue;
						}


						if (empty($af_chkout_loc)) {
							continue;
						}

						if ('af_card_fee' == $af_donat_camp_fee_t) {
							continue;
						}
						?>
						<option value="<?php echo esc_attr($af_campgns); ?>">
						<?php echo esc_html__(get_the_title($af_campgns), 'af_donation'); ?>
						</option>
						<?php

					}

					if ('yes' == get_option('af_chkt_alow_mul_donat')) {
						?>
						<option value="multp_donate"><?php echo esc_html__('Multiple donation', 'af_donation'); ?></option>
						<?php
					}
					?>
				</select>
			</div>
		</div>
		<div class="af_dont_btn_div_chk">
			<button type="button" class=" af_dont_btn_chk" id="af_donat_btn_chk" name="">
				<?php

				if (!empty(get_option('af_dona_btn_txt'))) {
					echo esc_html__(get_option('af_dona_btn_txt'), 'af_donation');
				} else {
						echo esc_html__('Donate', 'af_donation');
				}

				?>

			</button>
		</div>
	</div>

	<div id="myModal" class="modal">
		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>

				<?php
				if ('af_tbl_disp' == get_option('af_dona_chkt_disp_optn')) {
					$this->af_donat_show_campigns_in_popup_table();
				} elseif ('af_flx_disp' == get_option('af_dona_chkt_disp_optn')) {

					$this->af_donat_multi_campaigns_flex();
				} elseif ('af_list_disp' == get_option('af_dona_chkt_disp_optn')) {

					$this->af_donat_show_campigns_in_popup_list();
				}
				?>
		</div>

	</div>
				<?php


			} elseif ('on_popup' == get_option('af_dona_chkt_disp_opt')) {

				if ('auto_show' == get_option('af_dona_chkt_disp_frmt')) {

					?>
	<input type="hidden" name="af_show_auto_popup" class="af_show_auto_popup"
		value="<?php echo esc_attr(get_option('af_dona_chkt_disp_opt')); ?>">
	<div id="myModal" class="modal">
		<!-- Modal content -->
		<div class="modal-content">
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_chkt_popup_hadng'), 'af_donation'); ?></h3>
			<span class="close">&times;</span>
					<?php

					if ('af_tbl_disp' == get_option('af_dona_chkt_disp_optn')) {

						$this->af_donat_show_campigns_in_popup_table();
					} elseif ('af_flx_disp' == get_option('af_dona_chkt_disp_optn')) {

						$this->af_donat_multi_campaigns_flex();
					} elseif ('af_list_disp' == get_option('af_dona_chkt_disp_optn')) {

						$this->af_donat_show_campigns_in_popup_list();
					}
					?>
		</div>

	</div>
					<?php

				} elseif ('butn' == get_option('af_dona_chkt_disp_frmt')) {

					if ('af_tbl_disp' == get_option('af_dona_chkt_disp_optn')) {
						$this->af_show_donate_camp_btn();
						?>
	<div id="myModal" class="modal">
		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_chkt_popup_hadng'), 'af_donation'); ?>
			</h3>
						<?php
								$this->af_donat_show_campigns_in_popup_table();
						?>
		</div>

	</div>

						<?php
					} elseif ('af_flx_disp' == get_option('af_dona_chkt_disp_optn')) {
						$this->af_show_donate_camp_btn();
						?>

	<div id="myModal" class="modal">
		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_chkt_popup_hadng'), 'af_donation'); ?>
			</h3>
						<?php
								$this->af_donat_multi_campaigns_flex();
						?>
		</div>

	</div>

						<?php

					} elseif ('af_list_disp' == get_option('af_dona_chkt_disp_optn')) {
						$this->af_show_donate_camp_btn();
						?>

	<div id="myModal" class="modal">
		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_chkt_popup_hadng'), 'af_donation'); ?>
			</h3>
						<?php
								$this->af_donat_show_campigns_in_popup_list();
						?>
		</div>

	</div>
						<?php
					}
				}
			}
		}

		public function af_show_donate_camp_btn() {
			?>
	<button type="button" name="af_donat_opn_popup" class="af_donat_opn_popup" id="myBtn">
			<?php
			if (is_checkout()) {
				if (!empty(get_option('af_chkt_shw_btn_txt'))) {
					echo esc_html__(get_option('af_chkt_shw_btn_txt'), 'af_donation');
				} else {
					echo esc_html__('Donate', 'af_donation');
				}
			}
			if (is_cart()) {
				if (!empty(get_option('af_cart_shw_btn_txt'))) {
					echo esc_html__(get_option('af_cart_shw_btn_txt'), 'af_donation');
				} else {
					echo esc_html__('Donate', 'af_donation');
				}
			}

			?>
	</button>
			<?php
		}

		public function af_donat_optn_show_crt() {

			$af_check_cart       = 'false';
			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'ids',
					'order'       => 'DSC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			foreach ($af_wc_donat_rule_id as $key => $af_check) {
				$af_cart_loc = get_post_meta($af_check, 'af_cart_loc', true);
				if (!empty($af_cart_loc)) {
					$af_check_cart = 'true';
				}
			}

			if ('false' == $af_check_cart) {
				return;
			}
			if ('on_page' == get_option('af_cart_display_typ')) {

				if ('af_tbl_disp' == get_option('af_donat_cart_option')) {

					$this->af_donat_show_campigns_in_popup_table();
				} elseif ('af_flx_disp' == get_option('af_donat_cart_option')) {

					$this->af_donat_multi_campaigns_flex();
				} elseif ('af_list_disp' == get_option('af_donat_cart_option')) {

					$this->af_donat_show_campigns_in_popup_list();
				}
			} elseif ('on_popup' == get_option('af_cart_display_typ')) {

				if ('auto_show' == get_option('af_cart_display_format')) {

					?>
	<input type="hidden" name="af_show_auto_popup" class="af_show_auto_popup"
		value="<?php echo esc_attr(get_option('af_cart_display_typ')); ?>">
	<div id="myModal" class="modal">
		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_cart_popup_hadng'), 'af_donation'); ?>
			</h3>
					<?php
					if ('af_tbl_disp' == get_option('af_donat_cart_option')) {

						$this->af_donat_show_campigns_in_popup_table();
					} elseif ('af_flx_disp' == get_option('af_donat_cart_option')) {

						$this->af_donat_multi_campaigns_flex();
					} elseif ('af_list_disp' == get_option('af_donat_cart_option')) {

						$this->af_donat_show_campigns_in_popup_list();
					}
					?>
		</div>

	</div>
					<?php

				} elseif ('butn' == get_option('af_cart_display_format')) {

					if ('af_tbl_disp' == get_option('af_donat_cart_option')) {
						$this->af_show_donate_camp_btn();
						?>

	<div id="myModal" class="modal">

		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_cart_popup_hadng'), 'af_donation'); ?>
			</h3>
						<?php
								$this->af_donat_show_campigns_in_popup_table();
						?>
		</div>

	</div>

						<?php
					} elseif ('af_flx_disp' == get_option('af_donat_cart_option')) {
						$this->af_show_donate_camp_btn();
						?>

	<div id="myModal" class="modal">

		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_cart_popup_hadng'), 'af_donation'); ?>
			</h3>
						<?php
								$this->af_donat_multi_campaigns_flex();
						?>
		</div>

	</div>

						<?php

					} elseif ('af_list_disp' == get_option('af_donat_cart_option')) {
						$this->af_show_donate_camp_btn();
						?>

	<div id="myModal" class="modal">

		<!-- Modal content -->
		<div class="modal-content">
			<span class="close">&times;</span>
			<h3 class="af_donat_popup_head"><?php echo esc_html__(get_option('af_cart_popup_hadng'), 'af_donation'); ?>
			</h3>
						<?php
								$this->af_donat_show_campigns_in_popup_list();
						?>
		</div>

	</div>

						<?php
					}
				}
			}
		}

		public function af_dont_disp_amt_optn_chkt( $af_rule_id ) {

			$af_max_donat_amt = 0;

			$af_cart_loc = get_post_meta($af_rule_id, 'af_cart_loc', true);

			$af_donat_goal_amot = get_post_meta($af_rule_id, 'af_donat_goal_amot', true);

			$af_amt_type = get_post_meta($af_rule_id, 'af_amt_type', true);

			$get_table_count = get_post_meta($af_rule_id, 'get_table_count', true);

			$af_donat_choice = get_post_meta($af_rule_id, 'af_donat_choice', true);

			$af_min_donat_amt = get_post_meta($af_rule_id, 'af_min_donat_amt', true);

			$af_max_donat_amt = get_post_meta($af_rule_id, 'af_max_donat_amt', true);

			$af_enble_other_optn = get_post_meta($af_rule_id, 'af_enble_other_optn', true);

			$af_show_other_optn = get_post_meta($af_rule_id, 'af_show_other_optn', true);

			$af_chk_dont_typ = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);

			$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

			$af_donat_camp_t = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_cart_slct_fee = get_post_meta($af_rule_id, 'af_cart_slct_fee', true);

			$af_define_donat_choice = get_post_meta($af_rule_id, 'af_define_donat_choice', true);

			if ('af_perce' == $af_cart_slct_fee) {
				$af_per_number = get_post_meta($af_rule_id, 'af_amount_in_per', true);
				$af_total      = WC()->cart->get_subtotal();

				$af_donat_amt = ( $af_per_number / 100 ) * $af_total;
			} elseif ('af_fix' == $af_cart_slct_fee) {
				$af_donat_amt = get_post_meta($af_rule_id, 'af_fix_amount', true);
			}

			$product_id     = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
			$donated_amount = 0;
			$all_order      = wc_get_orders(
				array(
					'type' => 'shop_order',
				)
			);
			foreach ($all_order as $key => $value) {

				foreach ($value->get_items() as $key => $pro_item) {

					if ($product_id == $pro_item->get_product_id()) {

						$donated_amount += $pro_item->get_subtotal();
					}
				}
			}

			if (!empty($donated_amount)) {
				$af_max_donat_amt = $af_donat_goal_amot - $donated_amount;
			}

			?>

	<div class="af_donat_optn_in_chkt">
			<?php
			if ('af_dona_fee_base' == $af_donat_camp_t) {
				if ('af_round_fee' == $af_donat_camp_fee_t) {

					$af_donat_amt = $this->af_donat_round_of_calcu($af_rule_id);
					?>
					<div class="af_fee_amount_chkout">

						<div class="af_fee_amount_chkout_lbl">
							<h4><?php echo esc_html__('Amount', 'af_donation'); ?></h4>
						</div>
						<div class="af_fee_amount_chkout_amt">
							<label><?php echo wp_kses_post(wc_price($af_donat_amt)); ?></label>
						</div>
					</div>
					<?php
					die();
				} elseif ('af_normal_fee' == $af_donat_camp_fee_t) {


					?>
					<div class="af_fee_amount_chkout">
						<div class="af_fee_amount_chkout_lbl">
							<h4><?php echo esc_html__('Amount', 'af_donation'); ?></h4>
						</div>
						<div class="af_fee_amount_chkout_amt">
							<label><?php echo wp_kses_post(wc_price($af_donat_amt)); ?></label>
						</div>
					</div>
					<?php
					die();
				}
			}

			if ( 1 <= $get_table_count || !empty($af_enble_other_optn) || ( 'af_ena_recu' == $af_donat_choice && 'af_define_recu' != $af_define_donat_choice ) ) {

				?>
		<div class="af_dona_rec_opt_chkout">

				<?php
				if ('af_ena_recu' == $af_donat_choice && 'af_dona_prod_base' == $af_donat_camp_t ) {
					if ('af_define_recu' == $af_define_donat_choice) {
						?>
			<div class="af_dona_rec_opt_chkout_lft">
				<label><?php echo esc_html__('Recurring option', 'af_donation'); ?></label>
			</div>
			<div class="af_dona_rec_opt_chkout_right">
						<?php
							$this->af_define_recu_save_data_for_shortcode($af_rule_id);
						?>
			</div>
							<?php
					} else {

						?>
			<div class="af_dona_rec_opt_chkout_lft">
				<label><?php echo esc_html__('Recurring Option', 'af_donation'); ?></label>
			</div>
						<?php

						$af_time_period   = array( 'day', 'week', 'month', 'year' );
						$af_interval      = 6;
						$af_interval_chek = 2;
						?>
			<div class="af_dona_rec_opt_chkout_right">
				<select class="af_donat_sub_other_chk af_donat_inteval" name="af_sub_period_interval">
					<option value="1"><?php echo esc_html__('every ', 'af_donation'); ?></option>
							<?php
							while ($af_interval_chek <= $af_interval) {
								?>
					<option value="<?php echo esc_attr($af_interval_chek); ?>">
								<?php echo esc_html__('every ' . $af_interval_chek . 'th', 'af_donation'); ?></option>
								<?php
									++$af_interval_chek;
							}
							?>
				</select>
				<select name="af_sub_period" class="af_admin_recu_lnght af_donat_period af_donat_sub_other_chk">
							<?php

							foreach ($af_time_period as $key => $value) {
								?>
					<option value="<?php echo esc_attr($value); ?>"><?php echo esc_html__($value, 'af_donation'); ?>
					</option>
								<?php

							}
							?>
				</select>

				<input type="number" name="af_dont_lngt" class="af_donat_sub_other_chk af_donat_length"
					id="af_donat_sub_other">
			</div>
							<?php

					}
				}
				?>
		</div>

		<div class="af_donat_amt_optn_chekot_main">
				<?php
				if ('af_define_recu' == $af_define_donat_choice) {

					die();
				}
				for ($i = 1; $i <= $get_table_count; $i++) {
					$af_dont_leve_lbl = get_post_meta($af_rule_id, 'af_donat_text' . $i, true);
					$af_dont_leve_val = get_post_meta($af_rule_id, 'af_donat_number' . $i, true);
					if (!empty($af_dont_leve_lbl)) {
						?>
			<div class="af_donat_amt_optn_chekot" id="af_donat_amt_optn_chekot<?php echo esc_attr($i); ?>">
				<input type="radio" name="af_slct_lvl_optn" data-rule_id="<?php echo esc_attr($i); ?>"
					class="af_amt_optn_chkt af_amt_optn_chkt<?php echo esc_attr($i); ?>"
					id="<?php echo esc_attr($af_dont_leve_val); ?>" value="<?php echo esc_attr($af_dont_leve_val); ?>">
				<label class="af_donat_amt_optn_chekot_lbl" for="<?php echo esc_attr($af_dont_leve_val); ?>">

						<?php echo esc_html__($af_dont_leve_lbl, 'af_donation'); ?>
				</label>
			</div>

						<?php
					}
				}

				$placeholder           = '';
				$show_one_other_option = false;

				if ('yes' == $af_enble_other_optn) {

					if ('pre_define' == $af_amt_type) {
						$af_min_donat_amt = 0;
						if (!empty($af_donat_goal_amot)) {
							$af_max_donat_amt = $af_donat_goal_amot;
							$af_min_donat_amt = 0;
						}
					} elseif ('custome_value' == $af_amt_type) {
						$af_min_donat_amt = get_post_meta($af_rule_id, 'af_min_donat_amt', true);
						$af_max_donat_amt = get_post_meta($af_rule_id, 'af_max_donat_amt', true);

						if ( !empty( $af_min_donat_amt ) && !empty( $af_max_donat_amt ) ) {
							$placeholder = $af_min_donat_amt . '-' . $af_max_donat_amt;
						} elseif ( !empty( $af_min_donat_amt ) ) {
							$placeholder = $af_min_donat_amt . '-';
						} elseif ( !empty( $af_max_donat_amt ) ) {
							$placeholder = '0-' . $af_max_donat_amt;
						}
					}

					if ('af_show_in_optn' == $af_show_other_optn) {

						?>
						<div class="af_donat_amt_optn_chekot" id="af_donat_amt_optn_chekot<?php echo esc_attr($i); ?>">
							<input type="radio" name="af_slct_lvl_optn" data-rule_id="<?php echo esc_attr($i); ?>"
								class="af_amt_optn_chkt af_amt_optn_chkt<?php echo esc_attr($i); ?>"
								id="<?php echo esc_attr($af_dont_leve_val); ?>" value="af_other">
							<label class="af_donat_amt_optn_chekot_lbl" for="<?php echo esc_attr($af_dont_leve_val); ?>">
									<?php echo esc_html__('Other amount', 'af_donation'); ?>
							</label>
						</div>

						<?php
					} elseif ('af_show_other_optn' == $af_show_other_optn) {

						$show_one_other_option = true;

						?>
						<input type="number" name="af_other_input" max="<?php echo esc_attr($af_max_donat_amt); ?>"
							min="<?php echo esc_attr($af_min_donat_amt); ?>"
							placeholder='<?php echo esc_attr($placeholder); ?>'
							class="af_donat_otr_amt_btn">
						<?php
					}
				}
				?>
				</div>
				<?php
				if ( ! $show_one_other_option ) {
					
					?>
				<div class="af_donat_otr_amt_">
					<label><?php echo esc_html__('Custom Amount', 'af_donation'); ?></label>

					<input type="number" name="af_other_input" max="<?php echo esc_attr($af_max_donat_amt); ?>"
						min="<?php echo esc_attr($af_min_donat_amt); ?>"
						placeholder='<?php echo esc_attr($placeholder); ?>'
						class="af_donat_otr_amt_btn">
				</div>
					<?php
				}
			}
			?>

	</div>
			<?php
			die();
		}

		public function af_donat_show_campigns_in_popup_list() {

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$af_donat_camp_t = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

				if (empty($af_donat_camp_t)) {
					continue;
				}

				$check_dont_type     = get_post_meta($af_rule_id, 'af_donat_camp_t', true);
				$af_donat_prod_is    = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_chkout_loc       = get_post_meta($af_rule_id, 'af_chkout_loc', true);
				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);
				$af_cart_loc         = get_post_meta($af_rule_id, 'af_cart_loc', true);

				if (is_checkout()) {

					if (empty($af_chkout_loc)) {
						continue;
					}
				}

				if (is_cart()) {
					if (empty($af_cart_loc)) {
						continue;
					}
				}

				if ('af_card_fee' == $af_donat_camp_fee_t) {
					continue;
				}

				$this->af_donat_camp_multi_disp_list($af_rule_id, $af_donat_prod_is, '');
			}
		}

		public function af_donat_camp_multi_disp_list( $af_rule_id, $af_donat_prod_is, $af_check_if_shortcode ) {
			$af_donat_enable_goal        = get_post_meta($af_rule_id, 'af_donat_enable_goal', true);
			$af_chkout_loc               = get_post_meta($af_rule_id, 'af_chkout_loc', true);
			$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_rule_id);
			$af_cart_loc                 = get_post_meta($af_rule_id, 'af_cart_loc', true);

			if (!empty($af_cart_loc) || 'short_code' == $af_check_if_shortcode) {
				?>
	<div class="af_donat_main_div_in_popup">
		<ul>

				<?php
						$this->af_donat_multi_product_asfee_display($af_rule_id, $af_donat_prod_is, '');
				?>

		</ul>
	</div>

				<?php
			} elseif (!empty($af_chkout_loc)) {

				$this->af_donat_multi_product_asfee_display($af_rule_id, $af_donat_prod_is, 'card_fee');
			}
		}

		public function af_donat_multi_product_asfee_display( $af_rule_id, $af_donat_prod_is, $is_card_fees ) {

			$af_donat_goal_amot = get_post_meta($af_rule_id, 'af_donat_goal_amot', true);

			$af_amt_type = get_post_meta($af_rule_id, 'af_amt_type', true);

			$get_table_count = get_post_meta($af_rule_id, 'get_table_count', true);

			$af_min_donat_amt = get_post_meta($af_rule_id, 'af_min_donat_amt', true);

			$af_max_donat_amt = get_post_meta($af_rule_id, 'af_max_donat_amt', true);

			$af_enble_other_optn = get_post_meta($af_rule_id, 'af_enble_other_optn', true);

			$af_show_other_optn = get_post_meta($af_rule_id, 'af_show_other_optn', true);

			$af_rule_as_prod = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$af_donat_fee_msg = get_post_meta($af_rule_id, 'af_donat_fee_msg', true);

			$af_round_off_msg = get_post_meta($af_rule_id, 'af_round_off_msg', true);

			if (!empty($af_round_off_msg)) {
				$af_donat_fee_msg = $af_round_off_msg;
			}
			$af_chk_dont_typ = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_plac_hold_img = plugin_dir_url('') . 'wc-donation/assets/images/woocommerce-placeholder.png';

			$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

			$af_cart_slct_fee = get_post_meta($af_rule_id, 'af_cart_slct_fee', true);

			$af_donat_choice = get_post_meta($af_rule_id, 'af_donat_choice', true);

			$af_define_donat_choice = get_post_meta($af_rule_id, 'af_define_donat_choice', true);

			$af_slct_disp_typ_bar = get_post_meta($af_rule_id, 'af_slct_disp_typ_bar', true);

			$af_don_compaign_causes = get_post_meta( $af_rule_id, 'af_don_compaign_causes', true);

			$product_id_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$product_url = get_permalink($product_id_is);

			$af_fix_amount = 0;

			if ('af_perce' == $af_cart_slct_fee) {

				$af_per_number = get_post_meta($af_rule_id, 'af_amount_in_per', true);

				$af_total = WC()->cart->get_subtotal();

				$af_fix_amount = ( $af_per_number / 100 ) * $af_total;
			} elseif ('af_fix' == $af_cart_slct_fee) {
				$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);
			}

			if ('af_card_fee' == $af_donat_camp_fee_t) {
				if ('card_fee' != $is_card_fees) {
					return;
				}
			}
			?>
	<input type="hidden" class="af_show_optn" name="" value="<?php echo esc_attr($af_show_other_optn); ?>">
	<li class="af_donat_camp_li">
		<div class="af_disp_img_list_div">
			<?php
			if (!empty(wp_get_attachment_image_url(get_post_thumbnail_id($af_rule_id)))) {
				?>
			<a href="<?php echo esc_url($product_url); ?>"><img
					src="<?php echo esc_url(wp_get_attachment_image_url(get_post_thumbnail_id($af_rule_id))); ?>"></a>
				<?php
			} else {
				?>
			<a href="<?php echo esc_url($product_url); ?>"><img src="<?php echo esc_url($af_plac_hold_img); ?>"></a>
				<?php
			}
			?>

		</div>
		<div class="af_disp_data_list_div">

			<?php if ('af_dona_prod_base' == $af_chk_dont_typ) { ?>

				<h3> <a href="<?php echo esc_url($product_url); ?>"><?php echo esc_html__(get_the_title($af_rule_id), 'af_donation'); ?></a></h3>

				<?php

				$product = wc_get_product($af_rule_as_prod);

				if (!empty($product) && !empty($product->get_description())) { 
					?>

					<p class="af_camp_descp"> <?php echo esc_html__( wp_trim_words( $product->get_description(), 12, '...'), 'af_donation' ); ?> </p>
				
				<?php } ?>

				<table>
					<tr>
						<td><label><?php echo esc_html__(' Donate Amount', 'af_donation'); ?></label></td>
						<td class="af_donat_amt_opt_list">
							<?php
							if ('af_ena_recu' == $af_donat_choice) {

								if ('af_define_recu' != $af_define_donat_choice) {
										$this->af_dont_disp_amt_optn($af_rule_id);
								} else {
												$this->af_define_recu_save_data_for_shortcode($af_rule_id);
								}
							}

							if ('af_ena_recu' == $af_donat_choice && 'af_dona_prod_base' == $af_chk_dont_typ ) {

								if ('af_define_recu' != $af_define_donat_choice) {
									?>
							<h3><?php echo esc_html__('Recurring option', 'af_donation'); ?></h3>
									<?php
											$this->af_sub_prod_opts($af_rule_id);
								}
							} else {
									$this->af_dont_disp_amt_optn($af_rule_id);
							}
							?>
						</td>
					</tr>

					<?php

					if ( !empty( $af_don_compaign_causes ) ) { 
						?>
						<tr>
							<td><label><?php echo esc_html__(' Select Cause', 'af_donation'); ?></label></td>

							<td><?php $this->af_disp_causes($af_rule_id); ?></td>
						</tr>

					<?php } ?>

				</table>
				<?php
				$product_id_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

				$product_url = get_permalink($product_id_is);

			} else { 
				?>
			
				<h3><a href="<?php echo esc_url($product_url); ?>"><?php echo esc_html__(get_the_title($af_rule_id), 'af_donation'); ?></a></h3>
				
				<?php if (!empty($af_donat_fee_msg)) { ?>
			
					

					<p class="af_camp_descp"> <?php echo esc_html__( wp_trim_words( $af_donat_fee_msg , 12, '...' ), 'af_donation'); ?></p>
					
				<?php } ?>

				<ul>

					<li>
						<label><?php echo esc_html__(' Donate Amount', 'af_donation'); ?></label>
						<span>
							<?php

							if ('af_dona_fee_base' == $af_chk_dont_typ) {

								if ('af_round_fee' == $af_donat_camp_fee_t) {

									$round_off_amt_is = $this->af_donat_round_of_calcu($af_rule_id);
								
									?>
								
									<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
									value="<?php echo esc_attr($round_off_amt_is); ?>">
									
									<h4><?php echo wp_kses_post(wc_price($round_off_amt_is)); ?> </h4>
									
								<?php } elseif ('af_normal_fee' == $af_donat_camp_fee_t) { ?>

									<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
										value="<?php echo esc_attr($af_fix_amount); ?>">
									<h4><?php echo wp_kses_post(wc_price($af_fix_amount)); ?> </h4>
								
								<?php } elseif ('af_card_fee' == $af_donat_camp_fee_t) { ?>

									<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
										value="<?php echo esc_attr($af_fix_amount); ?>">
									<h4><?php echo wp_kses_post(wc_price($af_fix_amount)); ?> </h4>
											
									<?php 
								}

							} else {

								$this->af_dont_disp_amt_optn($af_rule_id);

							}
							?>
						</span>
					</li>

				</ul>
				
				<?php
						

				if (!empty( $af_don_compaign_causes ) ) { 
					?>
			
					<ul>
						
						<li>
							<label><?php echo esc_html__(' Select Cause', 'af_donation'); ?></label>
							<?php $this->af_disp_causes($af_rule_id); ?></li>
					</ul>
				
					<?php 
				}

			}

			?>
			</div>
			<div class="af_disp_btn_list_div">

				<div class="af_camp_bar_in_list">
					<?php

					if ('none' != $af_slct_disp_typ_bar) {
						$this->af_shoe_progress_bar_shortcode($af_rule_id);
					}

					?>
				</div>
				<div class="af_donat_btn_in_list">

					<?php
							$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_rule_id);
							update_post_meta($af_rule_id, 'af_donatio_close', '');
					if ('false' == $af_check_donat_goal_setting) {

						return;
					} elseif (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {

						$this->af_donation_close_msg($af_check_donat_goal_setting['close_donation']);
						update_post_meta($af_rule_id, 'af_donatio_close', 'close');
					} else {

						$this->af_donat_add_to_cart_btn($af_rule_id);
					}
					?>

				</div>
			</div>
		</li>

			<?php
		}



		public function af_donat_show_campigns_in_popup_table() {

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			?>
	<div class="af_donat_main_div_in_popup">
		<table>
			<tr>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[0])) {
					?>
				<th class="af_donat_tbl_pic"><?php echo esc_html__('Thumbnail', 'af_donation'); ?></th>
					<?php
				}
				?>
				<th class="af_donat_tbl_cn"> <?php echo esc_html__('Campaign Name', 'af_donation'); ?></th>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[1])) {
					?>
				<th class="af_donat_tbl_des"><?php echo esc_html__('Description', 'af_donation'); ?></th>
					<?php
				}
				?>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[2])) {
					?>
				<th class="af_donat_tbl_caus"><?php echo esc_html__('Causes', 'af_donation'); ?></th>
					<?php
				}
				?>
				<th class="af_donat_tbl_amt"><?php echo esc_html__('Amount', 'af_donation'); ?></th>

				<th class="af_donat_tbl_btn"></th>
			</tr>
			<?php


			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$check_dont_type     = get_post_meta($af_rule_id, 'af_donat_camp_t', true);
				$af_donat_prod_is    = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_chkout_loc       = get_post_meta($af_rule_id, 'af_chkout_loc', true);
				$af_cart_loc         = get_post_meta($af_rule_id, 'af_cart_loc', true);
				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

				if ('af_card_fee' == $af_donat_camp_fee_t) {
					continue;
				}

				if (is_checkout()) {
					if (empty($af_chkout_loc)) {
						continue;
					}
				}

				if (is_cart()) {
					if (empty($af_cart_loc)) {
						continue;
					}
				}

				$this->af_donat_camp_multi_disp_table($af_rule_id, $af_donat_prod_is, '');
			}
			?>
		</table>
	</div>
			<?php
		}

		public function af_donat_camp_multi_disp_table( $af_rule_id, $af_donat_prod_is, $af_check_if_shortcode ) {

			$af_donat_enable_goal = get_post_meta($af_rule_id, 'af_donat_enable_goal', true);

			$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_rule_id);
			if (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {
				update_post_meta($af_rule_id, 'af_donatio_close', 'close');

				if ('' == get_post_meta($af_rule_id, 'af_donatio_close_date', true)) {

					update_post_meta($af_rule_id, 'af_donatio_close_date', gmdate('Y-m-d'));
				}
			}
			$af_cart_loc = get_post_meta($af_rule_id, 'af_cart_loc', true);

			$af_donat_goal_amot = get_post_meta($af_rule_id, 'af_donat_goal_amot', true);

			$af_amt_type = get_post_meta($af_rule_id, 'af_amt_type', true);

			$get_table_count = get_post_meta($af_rule_id, 'get_table_count', true);

			$af_min_donat_amt = get_post_meta($af_rule_id, 'af_min_donat_amt', true);

			$af_max_donat_amt = get_post_meta($af_rule_id, 'af_max_donat_amt', true);

			$af_enble_other_optn = get_post_meta($af_rule_id, 'af_enble_other_optn', true);

			$af_show_other_optn = get_post_meta($af_rule_id, 'af_show_other_optn', true);

			$af_chk_dont_typ = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_donat_fee_msg = get_post_meta($af_rule_id, 'af_donat_fee_msg', true);

			$af_round_off_msg = get_post_meta($af_rule_id, 'af_round_off_msg', true);

			if (!empty($af_round_off_msg)) {
				$af_donat_fee_msg = $af_round_off_msg;
			}

			$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);

			$af_rule_as_prod = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$af_cart_slct_fee = get_post_meta($af_rule_id, 'af_cart_slct_fee', true);

			$af_donat_choice = get_post_meta($af_rule_id, 'af_donat_choice', true);

			$af_define_donat_choice = get_post_meta($af_rule_id, 'af_define_donat_choice', true);

			$af_slct_disp_typ_bar = get_post_meta($af_rule_id, 'af_slct_disp_typ_bar', true);

			if ('af_perce' == $af_cart_slct_fee) {
				$af_per_number = get_post_meta($af_rule_id, 'af_amount_in_per', true);
				$af_total      = WC()->cart->get_subtotal();

				if ( !empty( $af_per_number ) ) {
					$af_fix_amount = ( $af_per_number / 100 ) * $af_total;
				} else {
					$af_fix_amount = 0;
				}
				
			} elseif ('af_fix' == $af_cart_slct_fee) {
				$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);
			}

			$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

			$af_chkout_loc = get_post_meta($af_rule_id, 'af_chkout_loc', true);

			$af_plac_hold_img = plugin_dir_url('') . 'wc-donation/assets/images/woocommerce-placeholder.png';

			$product_id_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
			$product_url   = get_permalink($product_id_is);


			if (!empty($af_cart_loc) || 'short_code' == $af_check_if_shortcode || !empty($af_chkout_loc)) {

				?>

	<tr>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[0])) {
					?>
		<td class="af_donat_tbl_pic">
					<?php
					if (!empty(wp_get_attachment_image_url(get_post_thumbnail_id($af_rule_id)))) {
						?>
			<a href="<?php echo esc_url($product_url); ?>"><img
					src="<?php echo esc_url(wp_get_attachment_image_url(get_post_thumbnail_id($af_rule_id)), 'af_donation'); ?>"></a>
						<?php
					} else {
						?>
			<a href="<?php echo esc_url($product_url); ?>"><img src="<?php echo esc_url($af_plac_hold_img); ?>"></a>
							<?php
					}
					?>
		</td>
					<?php
				}


				?>
		<td class="af_donat_tbl_cn">
			<h3><a
					href="<?php echo esc_url($product_url); ?>"><?php echo esc_html__(get_the_title($af_rule_id), 'af_donation'); ?></a>
			</h3>
				<?php

				if ('none' != $af_slct_disp_typ_bar) {
					$this->af_shoe_progress_bar_shortcode($af_rule_id);
				}
				?>

		</td>
				<?php

				if (empty(get_option('af_donat_tble_clmn_disa')[1])) {
					?>
		<td class="af_donat_tbl_des">
					<?php

					if ('af_dona_fee_base' == $af_chk_dont_typ) {

						?>
			<label class="af_camp_descp"> <?php echo esc_html__($af_donat_fee_msg, 'af_donation'); ?></label>
						<?php
					} else {
						$product = wc_get_product($af_rule_as_prod);

						if (!empty($product)) {
							?>
			<label class="af_camp_descp"> <?php echo esc_html__( wp_trim_words( $product->get_description(), 10, '...' ), 'af_donation'); ?> </label>
								<?php
						}
					}
					?>
		</td>
					<?php
				}

				if (empty(get_option('af_donat_tble_clmn_disa')[2])) {
					?>
		<td class="af_donat_tbl_caus">
					<?php $this->af_disp_causes($af_rule_id); ?>
		</td>
					<?php
				}
				?>
		<td class="af_donat_tbl_amt">

				<?php
				if ('af_dona_fee_base' == $af_chk_dont_typ) {
					if ('af_round_fee' == $af_donat_camp_fee_t) {

						$round_off_amt_is = $this->af_donat_round_of_calcu($af_rule_id);
						?>
			<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
				value="<?php echo esc_attr($round_off_amt_is); ?>">
			<h4> <?php echo wp_kses_post(wc_price($round_off_amt_is)); ?> </h4>
						<?php

					} else {
						?>
			<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
				value="<?php echo esc_attr($af_fix_amount); ?>">
			<h4> <?php echo wp_kses_post(wc_price($af_fix_amount)); ?> </h4>
						<?php
					}
				} elseif ('af_ena_recu' == $af_donat_choice) {

					if ('af_define_recu' != $af_define_donat_choice) {
						$this->af_dont_disp_amt_optn($af_rule_id);
					} else {
						$this->af_define_recu_save_data_for_shortcode($af_rule_id);
					}
				}
				if ('af_ena_recu' == $af_donat_choice && 'af_dona_prod_base' == $af_chk_dont_typ ) {

					if ('af_define_recu' != $af_define_donat_choice) {
						?>
			<h3><?php echo esc_html__('Recurring option', 'af_donation'); ?></h3>
						<?php
						$this->af_sub_prod_opts($af_rule_id);
					}
				} else {
					$this->af_dont_disp_amt_optn($af_rule_id);
				}

				?>
		</td>

		<td class="af_donat_tbl_btn">

				<?php
						$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_rule_id);
						update_post_meta($af_rule_id, 'af_donatio_close', '');
				if ('false' == $af_check_donat_goal_setting) {

					return;
				} elseif (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {
					$this->af_donation_close_msg($af_check_donat_goal_setting['close_donation']);
					update_post_meta($af_rule_id, 'af_donatio_close', 'close');
				} else {

					$this->af_donat_add_to_cart_btn($af_rule_id);
				}
				?>


		</td>
	</tr>

				<?php
			}
		}

		public function af_donat_round_of_calcu( $af_rule_id ) {

			$af_donat_round_off_mul = (float) get_post_meta($af_rule_id, 'af_donat_round_off_mul', true);
			$cart_total             = WC()->cart->get_subtotal();

			if ( wc()->cart->is_empty() || empty( $af_donat_round_off_mul ) ) {
				return;
			}

			$chek_round        = 1;
			$chek_round_amount = 0;

			$float_value = (float) $cart_total;
			if (strval($float_value) == $cart_total) {
				$check_is_float = true;
			} else {
				return 0;
			}

			while ($chek_round_amount <= $cart_total) {
				$chek_round_amount = $chek_round * $af_donat_round_off_mul;

				++$chek_round;
			}

			if ($chek_round_amount - $cart_total == $af_donat_round_off_mul) {
				return 0;
			}
			return $chek_round_amount - $cart_total;
		}

		public function af_donat_multi_campaigns_flex() {

			?>
	<div class="af_donat_main_div_in_flex_">
			<?php
				$af_wc_donat_rule_id = get_posts(
					array(
						'numberposts' => -1,
						'post_status' => 'any',
						'post_type'   => 'af_wc_donat',
						'orderby'     => 'menu_order',
						'order'       => 'ASC',
						'fields'      => 'ids',
						'meta_query'  => array(
							array(
								'key'     => 'af_donatio_close',
								'value'   => 'close',
								'compare' => '!=',
							),
						),
					)
				);

			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$check_dont_type = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

				$af_chkout_loc = get_post_meta($af_rule_id, 'af_chkout_loc', true);

				$af_cart_loc = get_post_meta($af_rule_id, 'af_cart_loc', true);

				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

				if ('af_card_fee' == $af_donat_camp_fee_t) {
					continue;
				}

				if (is_checkout()) {
					if (empty($af_chkout_loc)) {
						continue;
					}
				}

				if (is_cart()) {
					if (empty($af_cart_loc)) {
						continue;
					}
				}

				$this->af_donat_camp_multi_disp_flex($af_rule_id, $af_donat_prod_is, '');
			}
			?>

	</div>
			<?php
		}

		public function af_donat_camp_multi_disp_flex( $af_rule_id, $af_donat_prod_is, $af_check_if_shortcode ) {
			$af_donat_enable_goal = get_post_meta($af_rule_id, 'af_donat_enable_goal', true);

			$af_cart_loc = get_post_meta($af_rule_id, 'af_cart_loc', true);

			$af_donat_goal_amot = get_post_meta($af_rule_id, 'af_donat_goal_amot', true);

			$af_amt_type = get_post_meta($af_rule_id, 'af_amt_type', true);

			$get_table_count = get_post_meta($af_rule_id, 'get_table_count', true);

			$af_min_donat_amt = get_post_meta($af_rule_id, 'af_min_donat_amt', true);

			$af_max_donat_amt = get_post_meta($af_rule_id, 'af_max_donat_amt', true);

			$af_enble_other_optn = get_post_meta($af_rule_id, 'af_enble_other_optn', true);

			$af_show_other_optn = get_post_meta($af_rule_id, 'af_show_other_optn', true);

			$af_chk_dont_typ = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);

			$af_cart_slct_fee = get_post_meta($af_rule_id, 'af_cart_slct_fee', true);

			$af_donat_fee_msg = get_post_meta($af_rule_id, 'af_donat_fee_msg', true);

			$af_round_off_msg = get_post_meta($af_rule_id, 'af_round_off_msg', true);

			$af_don_compaign_causes = get_post_meta( $af_rule_id, 'af_don_compaign_causes', true);

			if (!empty($af_round_off_msg)) {
				$af_donat_fee_msg = $af_round_off_msg;
			}

			$af_rule_as_prod = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$af_donat_choice = get_post_meta($af_rule_id, 'af_donat_choice', true);

			$af_define_donat_choice = get_post_meta($af_rule_id, 'af_define_donat_choice', true);

			if ('af_perce' == $af_cart_slct_fee) {
				$af_per_number = get_post_meta($af_rule_id, 'af_amount_in_per', true);
				$af_total      = WC()->cart->get_subtotal();

				$af_fix_amount = ( $af_per_number / 100 ) * $af_total;
			} elseif ('af_fix' == $af_cart_slct_fee) {
				$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);
			}

			$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

			$af_chkout_loc = get_post_meta($af_rule_id, 'af_chkout_loc', true);

			$af_plac_hold_img = plugin_dir_url('') . 'wc-donation/assets/images/woocommerce-placeholder.png';

			$product_id_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$product_url = get_permalink($product_id_is);

			if (!empty($af_cart_loc) || 'short_code' == $af_check_if_shortcode || !empty($af_chkout_loc)) { 
				?>

				<div class="af_donat_flex_view_sub_div">
				
					<?php if (!empty(wp_get_attachment_image_url(get_post_thumbnail_id($af_rule_id)))) { ?>
						
						<a href="<?php echo esc_url($product_url); ?>"><img src="<?php echo esc_url(wp_get_attachment_image_url(get_post_thumbnail_id($af_rule_id))); ?>"></a>
						
					<?php } else { ?>

						<a href="<?php echo esc_url($product_url); ?>"><img src="<?php echo esc_url($af_plac_hold_img); ?>"></a>
					
					<?php } ?>

						<h3><a href="<?php echo esc_url($product_url); ?>"><?php echo esc_html__(get_the_title($af_rule_id), 'af_donation'); ?></a></h3>

					<?php if ('af_dona_fee_base' == $af_chk_dont_typ) { ?>

						<h3><?php echo esc_html__('Description', 'af_donation'); ?></h3>
						
						<label class="af_camp_descp"> <?php echo esc_html__($af_donat_fee_msg, 'af_donation'); ?> </label>
					
						<?php 
					} else {
					
						$product = wc_get_product($af_rule_as_prod);

						if (!empty($product)) {

							if (!empty($product->get_description())) { 
								?>
								<label class="af_camp_descp"> <?php echo esc_html__( wp_trim_words( $product->get_description(), 15, '...' ), 'af_donation'); ?> </label>

								<?php

							}
						}

					} 
					?>

					<ul>
						<li class="af_donat_amt_opt_fles">
							<label><strong><?php echo esc_html__(' Donate Amount', 'af_donation'); ?></strong></label>
							<?php

							if ('af_dona_fee_base' == $af_chk_dont_typ) {
								if ('af_round_fee' == $af_donat_camp_fee_t) {

												$round_off_amt_is = $this->af_donat_round_of_calcu($af_rule_id);
									?>
								<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
									value="<?php echo esc_attr($round_off_amt_is); ?>">
								<h4> <?php echo wp_kses_post(wc_price($round_off_amt_is)); ?> </h4>
											<?php

								} else {
									?>
									<input type="hidden" class="af_donat_fee_amount<?php echo esc_attr($af_rule_id); ?>"
										value="<?php echo esc_attr($af_fix_amount); ?>">
									<h4> <?php echo wp_kses_post(wc_price($af_fix_amount)); ?> </h4>
									<?php
								}
							} elseif ('af_ena_recu' == $af_donat_choice) {
								if ('af_define_recu' != $af_define_donat_choice) {
									$this->af_dont_disp_amt_optn($af_rule_id);
								} else {
									$this->af_define_recu_save_data_for_shortcode($af_rule_id);
								}
							} else {
								$this->af_dont_disp_amt_optn($af_rule_id);
							}
							if ('af_ena_recu' == $af_donat_choice && 'af_dona_prod_base' == $af_chk_dont_typ ) {


								if ('af_define_recu' != $af_define_donat_choice) {
									?>
									<h3><?php echo esc_html__('Recurring option', 'af_donation'); ?></h3>
									<?php
									$this->af_sub_prod_opts($af_rule_id);
								}
							}
							?>
						</li>
					</ul>

					<?php if (!empty( $af_don_compaign_causes ) ) { ?>

						<ul>
							<li><?php $this->af_disp_causes($af_rule_id); ?></li>
						</ul>

						<?php

					}

					$this->af_shoe_progress_bar_shortcode($af_rule_id);

					$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_rule_id);

					if ('false' == $af_check_donat_goal_setting) {

						return;

					} elseif (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {

						$this->af_donation_close_msg($af_check_donat_goal_setting['close_donation']);

						update_post_meta($af_rule_id, 'af_donatio_close', 'close');

					} else {

						$this->af_donat_add_to_cart_btn($af_rule_id);

					} 
					?>

				</div>

				<?php
			}
		}


		public function af_donat_add_to_cart_btn( $af_rule_id ) {

			$af_chk_dont_typ = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			if ('af_dona_fee_base' == $af_chk_dont_typ) { 
				?>

				<button type="button" data-rule_id="<?php echo esc_attr($af_rule_id); ?>"
					value="<?php echo esc_attr($af_rule_id); ?>" class="single_add_fee_button_ajax af_dont_btn_chk button alt">

					<?php 
					if (!empty(get_option('af_dona_btn_txt'))) {
						
						echo esc_html__(get_option('af_dona_btn_txt'), 'af_donation');
					
					} else {
								
						echo esc_html__('Donate', 'af_donation');

					} 
					?>

				</button>

				<?php } else { ?>

					<button type="button" data-rule_id="<?php echo esc_attr($af_rule_id); ?>"
						value="<?php echo esc_attr($af_rule_id); ?>" class="single_add_to_cart_button_ajax af_dont_btn_chk button alt">

						<?php 
						if (!empty(get_option('af_dona_btn_txt'))) {

							echo esc_html__(get_option('af_dona_btn_txt'), 'af_donation');

						} else {
							
							echo esc_html__('Donate', 'af_donation');
						
						} 
						?>

					</button>
				<?php
				}
		}

		public function af_define_recu_save_data_for_shortcode( $af_rule_id ) {

			$product_id = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$product = wc_get_product($product_id);

			if (!empty($product)) {

				$sub_price = $product->get_price();

				?>
				<input type="hidden" class="af_donat_other<?php echo esc_attr($af_rule_id); ?>" value="<?php echo esc_attr($sub_price); ?>">

				<?php 
				foreach ($product->get_meta_data() as $key => $meta_data) {

					if ('_subscription_period' == $meta_data->get_data()['key']) {

						$period = $meta_data->get_data()['value'];

					}

					if ('_subscription_period_interval' == $meta_data->get_data()['key']) {

						$interval = $meta_data->get_data()['value'];

					}

					if ('_subscription_length' == $meta_data->get_data()['key']) {

						$length = $meta_data->get_data()['value'];

					}
				} 
				?>

				<label>
					<?php
						$af_space = ' ';
						$af_for   = 'for';
						echo wp_kses_post(wc_price($sub_price));
						echo esc_html__(' every ' . $interval . $af_space . $period . $af_space . $af_for . $af_space . $length . $af_space . $period . 's', 'af_donation');
					?>
				</label>

				<?php
			}
		}



		public function af_disp_causes( $af_rule_id ) {

			$af_don_compaign_causes = get_post_meta($af_rule_id, 'af_don_compaign_causes', true);

			if (!empty($af_don_compaign_causes) && isset( $af_don_compaign_causes['name'] ) ) { 
				?>
	
				<div class="dropdown">

					<input class="dropbtn af_donat_selectd_casue af_donat_selectd_casue<?php echo esc_attr($af_rule_id); ?>" type="button" value="<?php echo esc_html__('Select Cause', 'af_donation'); ?>" name="af_donat_selectd_casue">


					<div class="dropdown-content">

						<?php

						$i = 0;

						foreach ( $af_don_compaign_causes['name'] as $index => $value ) {

							++$i;

							$image_url      = isset( $af_don_compaign_causes['img'][ $index ] ) ? $af_don_compaign_causes['img'][ $index ] : '';
							$af_cause_name  = isset( $af_don_compaign_causes['name'][ $index ] ) ? $af_don_compaign_causes['name'][ $index ] : '';
							$af_cause_descp = isset( $af_don_compaign_causes['description'][ $index ] ) ? $af_don_compaign_causes['description'][ $index ] : '';
							?>

							<button type="button" data-rule_id="<?php echo esc_attr($af_rule_id); ?>" class="af_slct_donat_cuse"
								name="af_slct_donat_cuse" value="<?php echo esc_attr($af_cause_name); ?>">
								<div class="af_cause_data">
									<div class="af_cause_data_left">
										<?php if (!empty($image_url)) { ?>

											<img src="<?php echo esc_url($image_url); ?>" width="20" height="15">
										
										<?php } ?>
									</div>
									<div class="af_cause_data_right">
										<p> <strong><?php echo esc_html__($af_cause_name, 'af_donation'); ?></strong> </p>
										<p> <?php echo esc_html__($af_cause_descp, 'af_donation'); ?> </p>
									</div>
								</div>
							</button>

						<?php } ?>

					</div>

				</div>

				<?php
			}
		}

		public function af_dont_disp_amt_optn( $af_rule_id ) {

			$af_max_donat_amt = 0;

			$af_rule_as_prod = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$af_amt_opt_type = get_post_meta($af_rule_id, 'af_amt_opt_type', true);

			$af_show_other_optn = get_post_meta($af_rule_id, 'af_show_other_optn', true);

			$af_enble_other_optn = get_post_meta($af_rule_id, 'af_enble_other_optn', true);

			$product_obj = wc_get_product($af_rule_as_prod);

			if (!empty($product_obj)) {

				$default_price = $product_obj->get_price();

				if (empty($af_amt_opt_type) && empty($af_enble_other_optn)) {

					if (!empty($default_price)) { 
						?>

						<label><?php echo wp_kses_post(wc_price($default_price)); ?></label>

						<?php

						return;
					}
				}
			}

			$af_cart_loc = get_post_meta($af_rule_id, 'af_cart_loc', true);

			$af_donat_goal_amot = get_post_meta($af_rule_id, 'af_donat_goal_amot', true);

			$af_amt_type = get_post_meta($af_rule_id, 'af_amt_type', true);

			$get_table_count = get_post_meta($af_rule_id, 'get_table_count', true);

			$af_min_donat_amt = get_post_meta($af_rule_id, 'af_min_donat_amt', true);

			$af_max_donat_amt = get_post_meta($af_rule_id, 'af_max_donat_amt', true);

			$af_chk_dont_typ = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_fix_amount = get_post_meta($af_rule_id, 'af_fix_amount', true);


			if (1 <= $get_table_count || 'af_show_in_optn' == $af_show_other_optn) {

				if (!empty($af_amt_opt_type) || !empty($af_enble_other_optn) && 'af_show_in_optn' == $af_show_other_optn) { 
					?>

					<div class="af_check_selet_optn_div">

						<select id="af_check_selet_optn" class="af_donat_amt_popup_selct<?php echo esc_attr($af_rule_id); ?>  af_donat_amt_popup_selct" data-rule_id="<?php echo esc_attr($af_rule_id); ?>">
						
							<?php 
							if (!empty($af_amt_opt_type)) {

								for ($i = 1; $i <= $get_table_count; $i++) {
									
									$af_dont_leve_lbl = get_post_meta($af_rule_id, 'af_donat_text' . $i, true);
									
									$af_dont_leve_val = get_post_meta($af_rule_id, 'af_donat_number' . $i, true)
				
									?>
									<option value="<?php echo esc_attr($af_dont_leve_val); ?>">
										
										<?php echo esc_html__($af_dont_leve_lbl, 'af_donation'); ?> </option>
										
									<?php
								
								}

							}

							if ('yes' == $af_enble_other_optn) {
								
								if ('af_show_in_optn' == $af_show_other_optn) { 
									?>

									<option value="af_dont_other"><?php echo esc_html__('Other Amount', 'af_donation'); ?></option>
								
									<?php
								
								}
				
							}

							?>

						</select>
					</div>
					<?php
				
				}
			
			}

			if ('pre_define' == $af_amt_type) {

				$af_min_donat_amt = 0;

				if (!empty($af_donat_goal_amot)) {

					$af_max_donat_amt = $af_donat_goal_amot;

					$af_min_donat_amt = 0;

				}

			} elseif ('custome_value' == $af_amt_type) {

				$af_max_donat_amt = $af_max_donat_amt;

				$af_min_donat_amt = $af_min_donat_amt;

			}

			$product_id = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

			$donated_amount = 0;
			
			$all_order = wc_get_orders(

				array(
				
					'type' => 'shop_order',
				
				)
			);

			foreach ($all_order as $key => $value) {

				foreach ($value->get_items() as $key => $pro_item) {

					if ($product_id == $pro_item->get_product_id()) {

						$donated_amount += $pro_item->get_subtotal();
					}
				}
			}

			if (!empty($af_enble_other_optn)) {

				if ('af_show_other_optn' == $af_show_other_optn) { 
					?>
			
					<input type="number" name="af_other_input" min="<?php echo esc_attr($af_min_donat_amt); ?>" max="<?php echo esc_attr($af_max_donat_amt); ?>" class="af_donat_other_ af_donat_other_<?php echo esc_attr($af_rule_id); ?>" placeholder="<?php echo esc_html__($af_min_donat_amt . '-' . $af_max_donat_amt, 'af_donation'); ?>">
				
				<?php } ?>
			
			<div class="af_donat_other_optn<?php echo esc_attr($af_rule_id); ?> af_donat_other_optn_cls ">
				<input type="number" name="af_other_input" min="<?php echo esc_attr($af_min_donat_amt); ?>" max="<?php echo esc_attr($af_max_donat_amt); ?>" class="af_donat_other af_donat_other<?php echo esc_attr($af_rule_id); ?>" placeholder="<?php echo esc_html__($af_min_donat_amt . '-' . $af_max_donat_amt, 'af_donation'); ?>">
			</div>

				<?php
		
			}
		}

		public function af_shoe_progress_bar_shortcode( $af_rule_id ) {

			$donated_amt_in_per   = 0;
			$af_donated_price     = 0;
			$donated_amount       = 0;
			$donated_count        = 0;
			$af_donat_goal_amot   = 0;
			$product_id           = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
			$af_donat_rule_       = get_post_meta($af_rule_id, 'af_donation_product_rule', true);
			$af_donat_goal_amot   = get_post_meta($af_rule_id, 'af_donat_goal_amot', true);
			$af_wc_goal_type_name = get_post_meta($af_rule_id, 'af_wc_goal_type_name', true);
			$af_slct_disp_typ_bar = get_post_meta($af_rule_id, 'af_slct_disp_typ_bar', true);

			$check_dont_type = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

			$af_donat_enable_goal =  get_post_meta($af_rule_id, 'af_donat_enable_goal', true);

			if ( 'af_enab_goal' != $af_donat_enable_goal ) {
				return;
			}

			$all_order = wc_get_orders(
				array(
					'type' => 'shop_order',
				)
			);
			if ('af_dona_fee_base' == $check_dont_type) {
				$donated_amount = get_post_meta($af_rule_id, 'af_donat_amt_on_camp_fee', true);
				$donated_count  = get_post_meta($af_rule_id, 'af_donat_count_camp_fee', true);
			} else {

				foreach ($all_order as $key => $value) {

					foreach ($value->get_items() as $key => $pro_item) {

						if ($product_id == $pro_item->get_product_id()) {
							++$donated_count;
							$donated_amount += $pro_item->get_subtotal();
						}
					}
				}
			}


			if ('amount' == $af_slct_disp_typ_bar) {

				if (!empty($af_donat_goal_amot)) {
					if (!empty($donated_amount)) {
						$donated_amt_in_per = ( $donated_amount / $af_donat_goal_amot ) * 100;
					} else {
						$donated_amt_in_per = 0;
					}
				}
				$donated_amt_in_per = number_format($donated_amt_in_per, 2);
				$af_donated_price   =  wc_price($donated_amount);
			} elseif ('percentage' == $af_slct_disp_typ_bar) {

				if (!empty($af_donat_goal_amot) && !empty($donated_amount)) {
					$donated_amt_in_per = ( $donated_amount / $af_donat_goal_amot ) * 100;
				}
				$donated_amt_in_per = number_format($donated_amt_in_per, 2);
				$af_donated_price   = $donated_amt_in_per . '%';
			} elseif ('Donat_no' == $af_slct_disp_typ_bar) {

				if (!empty($af_donat_goal_amot) && !empty($donated_amount)) {
					$donated_amt_in_per = ( $donated_amount / $af_donat_goal_amot ) * 100;
				}
				$donated_amt_in_per = number_format($donated_amt_in_per, 2);
				$af_donated_price   = $donated_count . ' donation';
			} else {
				return;
			}

			if ('100' < $donated_amt_in_per) {
				$donated_amt_in_per = 100;
			}

			?>
	<div class="af_bar_main">
		<div class="af_donat_progress_main">
			<div class="af_donat_progress_line"
				style="width: <?php echo esc_attr($donated_amt_in_per . '%'); ?>; max-width: 100%;">

				<label id="af_prog_lbl"><?php echo wp_kses_post($af_donated_price); ?></label>

			</div>
		</div>
		<div class="af_donat_progress_detail">
			<label class="af_lft_lbl"><?php echo wp_kses_post(wc_price(0)); ?></label>
			<label id="af_prog_lbl"><?php echo wp_kses_post(wc_price($af_donat_goal_amot)); ?></label>
		</div>
	</div>
			<?php
		}

		public function af_donat_open_card_fee() {

			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);
			$chek_if_card        = 'false';

			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$check_dont_type     = get_post_meta($af_rule_id, 'af_donat_camp_t', true);
				$af_donat_prod_is    = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_chkout_loc       = get_post_meta($af_rule_id, 'af_chkout_loc', true);
				$af_cart_loc         = get_post_meta($af_rule_id, 'af_cart_loc', true);
				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

				if (!empty($af_chkout_loc)) {

					if ('af_card_fee' == $af_donat_camp_fee_t) {
						$chek_if_card = 'true';
						?>
	<input type="hidden" class="chek_if_card_donat" value="<?php echo esc_attr($chek_if_card); ?>">
						<?php

					}
				}
			}
			?>
	<!-- The Modal -->
	<div id="af_donat_card_fee_Modal" class="af_donat_fee_payment_modal">
		<!-- Modal content -->
		<div class="af_donat_payment_modal_content">
			<h3><?php echo esc_html__(get_option('af_chkt_popup_hadng'), 'af_donation'); ?></h3>

			<span class="ad_donat_card_fee_close">&times;</span>
			<?php

					$this->af_donat_cart_free();
			?>
		</div>
	</div>
			<?php
		}

		public function af_donat_cart_free() {

			if ('af_tbl_disp' == get_option('af_dona_chkt_disp_optn')) {

				$this->af_donat_card_fee_in_popup_table();
			} elseif ('af_flx_disp' == get_option('af_dona_chkt_disp_optn')) {

				$this->af_donat_card_fee_flex();
			} elseif ('af_list_disp' == get_option('af_dona_chkt_disp_optn')) {

				$this->af_donat_card_fee_in_popup_list();
			} else {
				$this->af_donat_card_fee_flex();
			}
		}

		public function af_donat_card_fee_in_popup_table() {
			?>
	<div class="af_donat_main_div_in_popup">
		<table>
			<tr>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[0])) {
					?>
				<th class="af_donat_tbl_pic"><?php echo esc_html__('Thumbnail', 'af_donation'); ?></th>
					<?php
				}
				?>
				<th class="af_donat_tbl_cn"> <?php echo esc_html__('Campaign Name', 'af_donation'); ?></th>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[1])) {
					?>
				<th class="af_donat_tbl_des"><?php echo esc_html__('Description', 'af_donation'); ?></th>
					<?php
				}
				?>
				<?php
				if (empty(get_option('af_donat_tble_clmn_disa')[2])) {
					?>
				<th class="af_donat_tbl_caus"><?php echo esc_html__('Causes', 'af_donation'); ?></th>
					<?php
				}
				?>
				<th class="af_donat_tbl_amt"><?php echo esc_html__('Amount', 'af_donation'); ?></th>


				<th class="af_donat_tbl_btn"></th>
			</tr>
			<?php

					$af_wc_donat_rule_id = get_posts(
						array(
							'numberposts' => -1,
							'post_status' => 'any',
							'post_type'   => 'af_wc_donat',
							'orderby'     => 'menu_order',
							'order'       => 'ASC',
							'fields'      => 'ids',
							'meta_query'  => array(
								array(
									'key'     => 'af_donatio_close',
									'value'   => 'close',
									'compare' => '!=',
								),
							),
						)
					);

			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$check_dont_type = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

				$af_chkout_loc = get_post_meta($af_rule_id, 'af_chkout_loc', true);

				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

				if ('yes' == $af_chkout_loc) {

					if ('af_card_fee' == $af_donat_camp_fee_t) {

						$this->af_donat_camp_multi_disp_table($af_rule_id, $af_donat_prod_is, '');
					}
				}
			}
			?>
		</table>
	</div>
			<?php
		}

		public function af_donat_card_fee_flex() {

			?>
	<div class="af_donat_main_div_in_flex_">
			<?php
				$af_wc_donat_rule_id = get_posts(
					array(
						'numberposts' => -1,
						'post_status' => 'any',
						'post_type'   => 'af_wc_donat',
						'orderby'     => 'menu_order',
						'order'       => 'ASC',
						'fields'      => 'ids',
						'meta_query'  => array(
							array(
								'key'     => 'af_donatio_close',
								'value'   => 'close',
								'compare' => '!=',
							),
						),
					)
				);

			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$check_dont_type = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

				$af_chkout_loc = get_post_meta($af_rule_id, 'af_chkout_loc', true);

				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

				if ('yes' == $af_chkout_loc) {

					if ('af_card_fee' == $af_donat_camp_fee_t) {

						$this->af_donat_camp_multi_disp_flex($af_rule_id, $af_donat_prod_is, '');
					}
				}
			}
			?>

	</div>
			<?php
		}

		public function af_donat_card_fee_in_popup_list() {
			$af_wc_donat_rule_id = get_posts(
				array(
					'numberposts' => -1,
					'post_status' => 'any',
					'post_type'   => 'af_wc_donat',
					'orderby'     => 'menu_order',
					'order'       => 'ASC',
					'fields'      => 'ids',
					'meta_query'  => array(
						array(
							'key'     => 'af_donatio_close',
							'value'   => 'close',
							'compare' => '!=',
						),
					),
				)
			);

			foreach ($af_wc_donat_rule_id as $key => $af_rule_id) {

				$check_dont_type = get_post_meta($af_rule_id, 'af_donat_camp_t', true);

				$af_donat_prod_is = get_post_meta($af_rule_id, 'af_rule_as_prod', true);

				$af_chkout_loc = get_post_meta($af_rule_id, 'af_chkout_loc', true);

				$af_donat_camp_fee_t = get_post_meta($af_rule_id, 'af_donat_camp_fee_t', true);

				if ('yes' == $af_chkout_loc) {

					if ('af_card_fee' == $af_donat_camp_fee_t) {
						$this->af_donat_camp_multi_disp_list($af_rule_id, $af_donat_prod_is, '');
					}
				}
			}
		}

		public function af_donat_save_camp_data( $order_id ) {

			$order              = wc_get_order($order_id);
			$billing_email      = $order->get_billing_email();
			$donated_amount     = 0;
			$customer_id        = $order->get_customer_id();
			$af_donat_mail_info = array();
			$af_donat_is        = 'false';

			foreach ($order->get_items() as $key => $value) {

				$af_rule_id                  = get_post_meta($value->get_product_id(), 'af_donation_product_rule', true);
				$af_prod_as_rule             = get_post_meta($af_rule_id, 'af_rule_as_prod', true);
				$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_rule_id);
				if (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {
					update_post_meta($af_rule_id, 'af_donatio_close', 'close');

					if ('' == get_post_meta($af_rule_id, 'af_donatio_close_date', true)) {

						update_post_meta($af_rule_id, 'af_donatio_close_date', gmdate('Y-m-d'));
					}
				}
				if (!empty($af_prod_as_rule)) {
					if ($af_prod_as_rule == $value->get_product_id()) {
						$donated_amount += $value->get_subtotal();
						update_post_meta($af_rule_id, 'af_donat_amt_on_prod', $value->get_subtotal());
						$af_donat_is          = 'true';
						$af_donat_mail_info[] = array(
							'name'       => get_the_title($af_prod_as_rule),
							'price'      => $value->get_subtotal(),
							'cust_email' => $billing_email,
						);
					}
				}
			}

			$af_dont_amt_as_fee    = 0;
			$donated_amount_as_fee = 0;
			$af_fee_count          = 1;
			$get_donat_fee_date    = array();
			$af_dont_fee_arr       = WC()->session->get('af_done_fee_in_cart');


			if (!empty($af_dont_fee_arr)) {
				update_post_meta($order_id, 'af_donated_fee_array', $af_dont_fee_arr);

				foreach ($af_dont_fee_arr as $key => $af_rule) {
					$af_camp_id_of_fee  = $af_rule['rule_id_fee'];
					$af_dont_amt_of_fee = $af_rule['fee_amount'];

					$af_check_donat_goal_setting = $this->af_donat_camp_goal_setting($af_camp_id_of_fee);
					if (is_array($af_check_donat_goal_setting) && array_key_exists('close_donation', $af_check_donat_goal_setting)) {
						update_post_meta($af_camp_id_of_fee, 'af_donatio_close', 'close');

						if ('' == get_post_meta($af_camp_id_of_fee, 'af_donatio_close_date', true)) {

							update_post_meta($af_camp_id_of_fee, 'af_donatio_close_date', gmdate('Y-m-d'));
						}
					}

					$donated_amount_as_fee += $af_dont_amt_of_fee;

					if (!empty($af_camp_id_of_fee)) {
						$af_donated_price = get_post_meta($af_camp_id_of_fee, 'af_donat_amt_on_camp_fee', true);

						if (!empty($af_donated_price)) {
							$af_donated_price += $af_dont_amt_of_fee;
						} else {
							$af_donated_price = $af_dont_amt_of_fee;
						}
						update_post_meta($af_camp_id_of_fee, 'af_donat_amt_on_camp_fee', $af_donated_price);
						$get_donat_fee_date = get_post_meta($af_camp_id_of_fee, 'af_dont_fee_date', true);

						if ('' ==  $get_donat_fee_date) {
							update_post_meta($af_camp_id_of_fee, 'af_dont_fee_date', gmdate('Y-m-d'));
						} else {

							update_post_meta($af_camp_id_of_fee, 'af_dont_fee_date', gmdate('Y-m-d'));
						}

						$af_check_fee_count =    get_post_meta($af_camp_id_of_fee, 'af_donat_count_camp_fee', true);

						if (!empty($af_check_fee_count)) {
							++$af_fee_count;
							update_post_meta($af_camp_id_of_fee, 'af_donat_count_camp_fee', $af_fee_count);
						} else {
							update_post_meta($af_camp_id_of_fee, 'af_donat_count_camp_fee', $af_fee_count);
						}
					}
				}
			}

			if ('true' == $af_donat_is) {

				include_once AFWCD_PLUGIN_DIR . 'template/email/class-af-donat-thankyou-email.php';

				include_once AFWCD_PLUGIN_DIR . 'template/email/class-af-donat-receive-email.php';

				WC()->session->set('af_done_fee_in_cart_mail', $af_donat_mail_info);
				WC()->mailer()->emails['af_donation_thanks_mail']->trigger($af_donat_mail_info);
				WC()->mailer()->emails['af_donation_recieve_mail']->trigger($af_donat_mail_info);
			}

			update_post_meta($customer_id, 'donation_of_user_as_prod', $donated_amount);

			update_post_meta($customer_id, 'donation_of_user_as_fee', $donated_amount_as_fee);

			WC()->session->set('af_done_fee_in_cart', '');
		}
	}

			new AF_Wc_Donation_Front();
}

